/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"

ARITH_BASE bas_functions(unsigned char fun_ndx)
{
#ifdef MAXI_SYSTEM
short *var;
#endif
short param[6];
unsigned char bt,i;
short result = 0;
char parentheses_flag;
          get_token();
              if(*bas_token=='(')
                    parentheses_flag = 1;
              else
               if (bas_token_type == DELIMITER)
                   {
                    parentheses_flag = 0;
                    bas_prog_int -= last_token_len;
                   }
                 else
                       serror(0,1);

   switch(fun_ndx)
   {

    case DIPSWITCH:
/****************************************************
Action:
Returns state of DIP-switch
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
var = DIPSWITCH or
var = DIPSWITCH()
****************************************************/ 

           result = PINA;
        break;  
    case DISCRETEINPUT:
/****************************************************
Action:
Returns state of discrete inputs
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
var = DISCRETEINPUT or
var = DISCRETEINPUT()
****************************************************/ 
           result = PINC;
        break;
    case LOW:
/****************************************************
Action:
Returns the low byte of integer
Syntax:
var = LOW(expression)
****************************************************/           
          get_exp(&param[0]);
          result = param[0] & 0x00FF;
    break;
    case HIGH:
          get_exp(&param[0]);
          result = param[0] >> 8;
    break;
   case ABS:
/****************************************************
Action:
Returns absolute value of integer
Syntax:
var = ABS(expression)
****************************************************/           
          get_exp(&(param[0]));
          if(param[0]<0) param[0] = -param[0];
          result = param[0];
    break;
   case PEEK:
/****************************************************
Action:
Returns value of memory at pointed address
Syntax:
var = PEEK(address)
****************************************************/           
          get_exp(&(param[0]));
          result = ((unsigned char*)(0))[param[0]];
    break;
    case TESTBIT:
/****************************************************
Action:
Returns state of I/O pin
Syntax:
var = STATE(pin)
****************************************************/           
          get_exp(&param[0]);
           if(RAM_START[pio_table[param[0]].in] & pio_table[param[0]].mask)
                result = 1;
             else
                result = 0;
   break;
   case PULSEIN:
/*********************************************************************
Action:
Returns pulse width on the controller pin unit that are approximately 
1 uS at frequency of quartz 14.745 MHz 
:
var = PULSEIN(pin, option, timeout)
Note:
option:
0 - Waiting for raise edge and measurement pulse width
1 - Waiting for fall edge and measurement of pulse width
**********************************************************************/ 
          get_exp(&(param[0]));
          get_token();
              if(*bas_token!=',')
                       serror(0,1);
          get_exp(&(param[1]));
          get_token();
              if(*bas_token!=',')
                       serror(0,1);
          get_exp(&(param[2]));
        if (param[1] == 1) param[1] = 255;
      result = pulse_in(pio_table[param[0]].in, pio_table[param[0]].mask,param[1],param[2]);
   break;
    case SHIFTIN:
/*********************************************************************
Action:
Returns the incoming sequence of bits
Syntax:
var = SHIFTIN(data_pin, clock_pin, bits, delay, option, timeout)
Note:
data_pin  - incoming data
clock_pin - Synchro, mode defined in option 
Bits      - number of bits
Delay     - Delay in uSec for resonator 14.745 MHz
Option: 
           Mode of synchronization:
           clk_pin  output:
             0  the highest bit the first on rising edge
             1  the highest bit the first on falling edge
             2  the lowest bit the first on rising edge
             3  the lowest bit the first on falling edge
           clk_pin  input:
             option = option + 4 
timeout   -  Time in mSec on which expiration function returns 
             a zero and variable LASTERROR accepts value 1. 
             Value timeout is actual when clk_pin works 
             as a synchro_input
*********************************************************************/ 
      for(i=0;i<6;i++)
      {
         if(i)
             {
                 get_token();
                    if(*bas_token != ',')
                               serror(0,1);
             }
          get_exp(&(param[i]));
      }
if(param[4]&4)
result = pio_table[param[1]].in;
else
result = pio_table[param[1]].out;

result = shift_in( pio_table[param[0]].in,
                   pio_table[param[0]].mask,
                   result,
                   pio_table[param[1]].mask,
                   param[2],
                   param[3],
                   param[4],
                   param[5]);
    break;
   case READEEPROM:
/*********************************************************************
Action:
Reads byte from the address in EEPROM
Syntax:
Variable = READEEPROM(address)
*********************************************************************/
          get_exp(&param[0]);
     __EEGET(bt,param[0]);
     result = bt;
    break;
   case TWIREAD:
          get_exp(&param[0]);
          if(param[0])
          TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWEA);
          else
          TWCR = (1<<TWINT) | (1<<TWEN);
          while (!(TWCR & (1<<TWINT)));
          if ((TWSR & 0x08) == 0x08)
                last_error = TWI_ERROR;
       result = TWDR;
    break;
#ifdef MAXI_SYSTEM
   case GETATOMIC:
/*********************************************************************
Action:
Gets value from a variable used in an interrupt. During this operator 
executing interrupts are disabled. 
Syntax:
some_var = GETATOMIC(var)
*********************************************************************/
        var = get_var(1);
     __disable_interrupt();
     result = *var;
     __enable_interrupt();
   break;
   case CHN:
/*********************************************************************
Action:
Sets needed channel of I/O and returns zero
Synrax:
var=CHN(channel)
It is allowed to write: 
CHN(channel) 
or as an element of the print list
PRINT [list;] CHN(channel); [list]

The parameter channel can accept values:

For BASINT within ATMEGA32:
0 - console I/O
1 - reserved
2 - output on LCD / input from matrix keypad

For IO_CONTROLLER_WITH_ATMEGA64:
0 - console I/O UART0
1 - AUX console I/O UART1
2 - reserved

*********************************************************************/
         get_exp(&param[0]);
         cur_channel = param[0];
         result = 0;
   break;
   case AT:
/*********************************************************************
Action:
Sets the position of the printing symbol for PRINT operator 
Syntax:
PRINT AT(x,y);[list]
x  row position (from 1 to 80)
y  column position (from 1 to 24)
Example:

REM *********************************************
REM Print "This msg" in the center of the screen
REM  and set cursor to the left/up corner 
REM *********************************************
PRINT AT(35,12);This msg; AT(1,1); 

*********************************************************************/
         get_exp(&param[0]);
           get_token();
              if(*bas_token != ',')
              serror(0,1);
           get_exp(&param[1]);
           putchar(27);
           putchar('[');
           putstr(int_to_str(param[1]));
           putchar(';');
           putstr(int_to_str(param[0]));
           putchar('H');
           result = 0;
   break;
   case BIN:
         get_exp(&param[0]);
           get_token();
              if(*bas_token != ',')
              serror(0,1);
           get_exp(&param[1]);
           result = putbin(param[0],param[1]);
   break;
   case HEX:
/**********************************************************************************
Action:
HEX  puts to the console a value in hexadecimal form, 
Function HEX is an elements of output list for PRINT operator.
:
PRINT [list1; or ,] HEX(value, digits)[; or , [list2]]

value  value or expression
digits  number of printed digits

Example:
REM ************************************
REM Prints value in hex format
REM ************************************
10 INPUT X
     PRINT X,HEX(X,4)
GOTO 10 
**********************************************************************************/
         get_exp(&param[0]);
           get_token();
              if(*bas_token != ',')
              serror(0,1);
           get_exp(&param[1]);
           result = puthex(param[0],param[1]);
   break;
   case BCD:
/**********************************************************************************
Action:
BCD - puts to the console a value in BCD form, 
Function BCD is an elements of output list for PRINT operator.
:
PRINT [list1; or ,] BCD(value, digits)[; or , [list2]]

value  value or expression
digits  number of printed digits
**********************************************************************************/
         get_exp(&param[0]);
           get_token();
              if(*bas_token != ',')
              serror(0,1);
           get_exp(&param[1]);
           result = putbcd(param[0],param[1]);
   break;
#endif
   case LASTERROR:
/*********************************************************************************
Action:
Returns last error or critical situation code
Syntax:
var = LASTERROR() 
Note:
Error code  - Error
   0        - No errors
   1        - Timed out (PULSEIN, SHIFTIN)
   2        - TWI error
*********************************************************************************/
      result = last_error;
      last_error = 0;
   break;
   case CHR:
/********************************************************************************
Action:
Sends symbol to the console by its code that is result of expression. 
Using with PRINT operator 
Syntax::

PRINT [list1; or ,] CHR(val)[; or , [list2]]

val  symbol code from 0 to 255. All another integer values 
will be got as a low byte of word

Example:

REM ***************************************
REM Print symbol codes and symbol itself
REM ***************************************
FOR I=32 TO 127
     PRINT I,CHR(I)
NEXT  
*********************************************************************************/
         get_exp(&param[0]);
         putchar(param[0]);
         result = 1;
   break;
   case WAITKEY:
        result = getchar();
   break;
   case INKEY:
        result = get_char();
   break;
}
     if(parentheses_flag)
     {
      get_token();
          if(*bas_token!=')')
                    serror(0,1);
     }
return result;
}
/*******************************************************************************
Action:
Initializes the system to work with LCD.
Syntax:
LCDINIT mode
The parameter mode can accept values:
0 - single line display with consecutive addressing
1 - single line display but after the 7-th symbol the address in LCD RAM is 0x40
2 - two and more lines display
*******************************************************************************/
void lcdinit_exec(void)
{
short param;
      get_exp(&param);
  LCD_init(param);
}
/*****************************************************************
Action:
Generates START condition on SDA and SCL pins 
Syntax:
TWISTART
*****************************************************************/
void twistart(void)
{
  TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
  while (!(TWCR & (1<<TWINT)));
  if ((TWSR & 0xF8) != M_START)
             last_error = TWI_ERROR;
}
/*****************************************************************
Action:
Generates STOP condition on SDA and SCL pins
Syntax::
TWISTOP 
*****************************************************************/
void twistop(void)
{
TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
}
void twiwrite(void)
{
short val;
  get_exp(&val);
  TWDR = val;
  TWCR = (1<<TWINT) | (1<<TWEN);
  while (!(TWCR & (1<<TWINT)));
  if ((TWSR & 0x08) == 0x08)
                last_error = TWI_ERROR;
}
/*****************************************************************
Action:
Iinitializes TWI (I2C)
Syntax:

TWIINIT bps, prescale

bps  number for bps needed
prescale - can be defined from equation: 
SCL frequency = CPU Clock frequency / (16 + 2(bps) * 4^prescale)
******************************************************************/
void twiinit(void)
{
short br,prescaler;
      get_exp(&br);
      get_token();
            if(*bas_token != ',')
                 serror(0,1);
      get_exp(&prescaler);
PORTD |= (1<<PD0);
PORTD |= (1<<PD1);
TWBR = br;
TWSR = prescaler & 0x07;
}

// SHIFTOUT var,PINDATA,PINCLOCK,bits,delay,opt
// 0  MSB shifted out first when clock goes low
// 1  MSB shifted out first when clock goes high
// 2  LSB shifted out first when clock goes low
// 3  LSB shifted out first when clock goes high
/**************************************************************
Action:
Outputs contents of a variable as sequence of bits
Syntax:
SHIFTOUT var, data_pin, clock_pin, bits, delay, option
Note:

Var       - Variable contains a value to be converted to 
            consecutive code
Data_pin  - Output consecutive data
clock_pin - Synchro, mode defined in option 
Bits      - number of bits
Delay     - Delay in uSec for resonator 14.745 MHz
Option: 
        Mode of synchronization:
        clk_pin  output:
           0  the highest bit the first on rising edge
           1  the highest bit the first on falling edge
           2  the lowest bit the first on rising edge
           3  the lowest bit the first on falling edge
**************************************************************/ 
void shift_out(void)
{
short param[5];
short var;
unsigned char port_data,mask_data,port_clk,mask_clk,bits,delay,opt;
unsigned short mask16;
char i;

var = *get_var(0);
for(i=0;i<5;i++)
{
     get_token();
         if(*bas_token != ',')
                    serror(0,1);
  get_exp(&(param[i]));
}
port_data = pio_table[param[0]].out;
mask_data = pio_table[param[0]].mask;
port_clk  = pio_table[param[1]].out;
mask_clk  = pio_table[param[1]].mask;
bits = param[2];
delay = param[3];
opt = param[4];

   if(opt & 0x02) // LSB first
       mask16 = 1;
   else
       mask16 = 1 << (bits-1);

  for(;bits>0;bits--)
 {
      if(var & mask16) RAM_START[port_data] |= mask_data;
             else RAM_START[port_data] &= ~mask_data;



  if(opt & 0x01) // rising edge
     RAM_START[port_clk] |= mask_clk;
  else
     RAM_START[port_clk] &= ~mask_clk;


   if(opt & 0x02) // LSB first
      var >>= 1;
   else
      var <<= 1;
      for(i=0;i<delay;i++);
      RAM_START[port_clk] ^= mask_clk;
      for(i=0;i<delay;i++);
}
   RAM_START[port_data] |= mask_data;
   RAM_START[port_clk]  &= ~mask_clk;

}


/**************************************************************
Action:
Forms pulse on the pin
Syntax:
PULSEOUT pin, duration

pin  pin number
duration - duration in uSec for resonator 14.745 MHz
**************************************************************/
void pulseout(void)
{
short param1;
short param2;
  get_exp(&param1);
     get_token();
         if(*bas_token != ',')
                       serror(0,1);
  get_exp(&param2);
  formpulse(pio_table[param1].out,pio_table[param1].mask,param2);
}
/**************************************************************
Action:
Set the analog multiplexer up
Syntax:
SETADMUX value 
Note.
value = reference source + channel number

Reference source:
  0 - pin AREF
 64 - pin AVCC 
192 - internal 2.56 volt 
**************************************************************/ 
void setadmux(void)
{
short param1;
  get_exp(&param1);
  ADMUX = param1;
}
/**************************************************************
Action:
Writes byte to the address in EEPROM
Syntax:
WRITEEEPROM address, byte
**************************************************************/
void write_eeprom(void)
{
short param1,param2;

   get_exp(&param1);
        get_token();
          if(*bas_token != ',')
             { //putstr("\r\n  ");
              serror(0,1);
             }
   get_exp(&param2);
   __disable_interrupt();
   __EEPUT(param1,param2);
   __enable_interrupt();
}
/**************************************************************
Action:
Shifts value of variable left. The LSB is set to 0.
Syntax:
ROL variable, number of shifts
**************************************************************/
void rol(void)
{
unsigned short tmpu16;
short shifts;
short *var;
  var = get_var(1);
  get_exp(&shifts);
  tmpu16 = *var;
  tmpu16 <<= shifts;
  *var = (short)tmpu16;
}
/**************************************************************
Action:
Shifts value of variable right. The MSB is set to 0.
Syntax:
ROR variable, number of shifts
****************************************************************/
void ror(void)
{
unsigned short tmpu16;
short shifts;
short *var;
  var = get_var(1);
  get_exp(&shifts);
  tmpu16 = *var;
  tmpu16 >>= shifts;
  *var = (short)tmpu16;
}

/**********************************************************************
Action:
Returns the incoming sequence of bits
Syntax:
var = SHIFTIN(data_pin, clock_pin, bits, delay, option, timeout)
Note:
data_pin  - incoming data
clock_pin - Synchro, mode defined in option 
Bits      - number of bits
Delay     - Delay in uSec for resonator 14.745 MHz
Option:
    Mode of synchronization:
      clk_pin  output:
         0  the highest bit the first on rising edge
         1  the highest bit the first on falling edge
         2  the lowest bit the first on rising edge
         3  the lowest bit the first on falling edge
      clk_pin  input:
         option = option + 4 
timeout - Time in mSec on which expiration function 
          returns a zero and variable LASTERROR accepts 
          value 1. Value timeout is actual when 
          clk_pin works as synchro_input
**********************************************************************/
short shift_in(   unsigned char port_data,
                  unsigned char mask_data,
                  unsigned char port_clk,
                  unsigned char mask_clk,
                  unsigned char bits,
                  unsigned char delay,
                  unsigned char opt,
                  short timeout )
{
unsigned char mode,i;
unsigned short tmp16,mask16;
unsigned short result = 0;
   if(opt & 0x02) // LSB first
       mask16 = 1 << (bits-1);
   else
       mask16 = 1;

 if((opt&0x04) == 0)
 {
  for(;bits>0;bits--)
 {
  if(opt & 0x01) // rising edge
     RAM_START[port_clk] |= mask_clk;
  else
     RAM_START[port_clk] &= ~mask_clk;

      for(i=0;i<delay;i++);
      PORTC |= (1<<2);
      tmp16 = RAM_START[port_data];
      PORTC &= ~(1<<2);
      RAM_START[port_clk] ^= mask_clk;

      if(tmp16 & mask_data) tmp16 = mask16;
      else tmp16 = 0;


     if(opt & 0x02) // LSB first
      result >>= 1;
     else
      result <<= 1;

      result |= tmp16;
      for(i=0;i<delay;i++);
}
      RAM_START[port_clk] &= ~mask_clk;
}
 else /* external clock */
  {
   if(timeout)
    _CLI();
    delay_flag = 0;
    del_timer = timeout;
    _SEI();

   if(opt & 0x01)
    mode = 0xFF;
    else
    mode = 0x00;
    result = 0;
         for(;bits>0;bits--)
         {
             while((RAM_START[port_clk] ^ mode) & mask_clk)
             if (delay_flag) goto to_error;
             mode ^= 255;
             // find transition
             while((RAM_START[port_clk] ^ mode) & mask_clk)
             if (delay_flag) goto to_error;


             PORTC |= (1<<2);
             if(RAM_START[port_data] & mask_data) tmp16 = mask16;
             else tmp16 = 0;
             PORTC &= ~(1<<2);



             if(opt & 0x02) // LSB first
                   result >>= 1;
             else
                   result <<= 1;
                   result |= tmp16;

             mode ^= 255;


         }
  }



return (short)result;
to_error:
   last_error = TIME_OUT_ERROR;
   return 0;

}
/************************************************************
Action:
Returns pulse width on the controller pin unit that are 
approximately 1 uS at frequency of quartz 14.745 MHz 
Syntax:
var = PULSEIN(pin, option, timeout)
option:
     0 - Waiting for raise edge and measurement pulse width
     1 - Waiting for fall edge and measurement of pulse width 
*************************************************************/
short pulse_in(unsigned char port, unsigned char mask,unsigned char mode,short to)
{
unsigned short result;
// find start condition
result = 0;
 if(to)
 {
   _CLI();
    delay_flag = 0;
    del_timer = to;
    _SEI();
 }
      while((RAM_START[port] ^ mode) & mask)
        if (delay_flag) return 0;
      mode ^= 255;
// find transition
      while((RAM_START[port] ^ mode) & mask)
        if (delay_flag) goto to_error;
      mode ^= 255;
// measure interval
      while((RAM_START[port] ^ mode) & mask)
       {
        result++;
        if (delay_flag) goto to_error;
       }
  return result;
to_error:
  last_error = TIME_OUT_ERROR;
 return 0;

}
/*******************************************************************
Action:
Performs the scaling 
Syntax:
SCALE Variable, multiplier, divider

Example1:
REM ********************************************** 
REM Calculates percent of number X from number Y. 
REM First X * 100 and 
REM put result into 32 bit temporary variable M32, 
REM then M32 / Y and put result into X
REM ********************************************** 
SCALE X,100,Y 

Example1:
REM ************************************ 
REM The same, but 10 times more precision
REM ************************************ 
SCALE X,1000,Y

********************************************************************/
void scale(void)
{
short *var;
long  long_param1;
short short_param;

 var = get_var(1);
 get_exp(&short_param);
 long_param1 = *var;
 long_param1 = long_param1 * short_param;
   get_token();
  if(*bas_token!=',')
                    serror(1,1);
 get_exp(&short_param);
 *var = long_param1 / short_param;
}
/*********************************************************************
Action:
Defines the pin function of the controller pins. 

The controller pins have numbering from zero up to some maximum value that 
depends on the type of controller. 

The Sets of additional pin functions 
depends on type of the controller too. See table to reference. 

Syntax:
DEFPIN pin AS type

+-------+------------------------+
| type  |      function          |
+-------+------------------------+ 
|  DIN  |  Discrete input        |
+-------+------------------------+ 
|  DOUT |  Discrete output       |
+-------+------------------------+ 
|  AIN  |  Analog input          |
+-------+------------------------+ 
|  PWM  | Pulse width modulation |
+-------+------------------------+ 
 

****************************************************************************/
void defpin(void)
{
short param1;
  get_exp(&param1);
  get_token();
  if((bas_token_type == COMMAND) && (bas_tok == AS))
  {
   get_token();
    if(bas_token_type == COMMAND)
    {
      if(bas_tok == DIN)
        {
             if(pio_table[param1].func == (0x80 + 0))
              TCCR1A &= ~((1 << COM1A1) + (1 << COM1A0));
        else if(pio_table[param1].func == (0x80 + 1))
              TCCR1A &= ~((1 << COM1B1) + (1 << COM1B0));
#ifdef MEGA64
        else if(pio_table[param1].func == (0x80 + 2))
              TCCR1A &= ~((1 << COM1C1) + (1 << COM1C0));
#endif
         RAM_START[pio_table[param1].ddr] &= ~pio_table[param1].mask;
          RAM_START[pio_table[param1].out] |= pio_table[param1].mask;
        }
      else if(bas_tok == DOUT)
        {
             if(pio_table[param1].func == (0x80 + 0))
              TCCR1A &= ~((1 << COM1A1) + (1 << COM1A0));
        else if(pio_table[param1].func == (0x80 + 1))
              TCCR1A &= ~((1 << COM1B1) + (1 << COM1B0));
#ifdef MEGA64
        else if(pio_table[param1].func == (0x80 + 2))
          TCCR1A &= ~((1 << COM1C1) + (1 << COM1C0));
#endif
          RAM_START[pio_table[param1].ddr] |= pio_table[param1].mask;
        }
      else if(bas_tok == PWM)
        {
          if(pio_table[param1].func == (0x80 + 0))
             {
              RAM_START[pio_table[param1].ddr] |= pio_table[param1].mask;
              TCCR1B = (1 << CS10) + (1 << WGM12) + (0 << WGM13);

              TCCR1A |=  (1 << WGM10) + (1 << WGM11);
              TCCR1A &= ~((1 << COM1A1) + (1 << COM1A0));
              TCCR1A |=  (1 << COM1A1);
              OCR1AH  = 0;
              OCR1AL  = 0;
             }
       else if(pio_table[param1].func == (0x80 + 1))
             {
              RAM_START[pio_table[param1].ddr] |= pio_table[param1].mask;
              TCCR1B = (1 << CS10) + (1 << WGM12) + (0 << WGM13);

              TCCR1A |=  (1 << WGM10) + (1 << WGM11);
              TCCR1A &= ~((1 << COM1B1) + (1 << COM1B0));
              TCCR1A |=  (1 << COM1B1);
              OCR1BH  = 0;
              OCR1BL  = 0;
             }
#ifdef MEGA64
       else if(pio_table[param1].func == (0x80 + 2))
             {
              RAM_START[pio_table[param1].ddr] |= pio_table[param1].mask;
              TCCR1B = (1 << CS10) + (1 << WGM12) + (0 << WGM13);

              TCCR1A |=  (1 << WGM10) + (1 << WGM11);
              TCCR1A &= ~((1 << COM1C1) + (1 << COM1C0));
              TCCR1A |=  (1 << COM1C1);
              OCR1CH  = 0;
              OCR1CL  = 0;

             }
#endif
       else
           serror(19,1);
        }
      else if(bas_tok == AIN)
        {
         if((pio_table[param1].func & 0xF0)==0x40)
         {
          RAM_START[pio_table[param1].ddr] &= ~pio_table[param1].mask;
          RAM_START[pio_table[param1].out] &= ~pio_table[param1].mask;
          ADCSR  = (1 << ADEN) + (1 << ADFR) + 5;
          ADCSR  |= (1 << ADSC);
         }
         else serror(19,1);
        }
      else if(bas_tok == IIN)
        {

        }
    }
     else serror(0,1);
  } else
     serror(0,1);
}
/************************************************************************
Action:
Assigns value of variable used in interrupt subroutine. During this 
action interpreter disables interrupts to provide complete 
(atomic) updating a two-byte variable. It is necessary, as operation 
of giving contains a chain of several commands which could be 
broken off by the interrupt, providing access to the same variable..
Syntax:
PUTATOMIC var, value 
*************************************************************************/
void put_atomic(void)
{
short tmpu16;
short *var;
  var = get_var(1);
  get_exp(&tmpu16);
    __disable_interrupt();
     *var = tmpu16;
    __enable_interrupt();
}
/**************************************************************
Action:
Writes byte to memory or I/O port
Syntax:
POKE adr, val
Note: You should reference to avr datasheet to get the address 
of register. Remember there are two addresses: I/O and memory. 
PEEK and POKE operate with memory address and and you need to 
add 32 to get I/O address. 
**************************************************************/
void poke(void)
{
short param1,param2;

   get_exp(&param1);
        get_token();
          if(*bas_token != ',')
                       serror(0,1);
   get_exp(&param2);
   ((unsigned char*)(0))[param1]=param2;
}

#ifdef MAXI_SYSTEM
/************************************************************************************
Action:
Sets the console output attributes
Syntax:
ATTR  expression 

An expression defines output attributes:

0  standard brightness
1  more light brightness
4  underscore
5  blinking
7  color inverting
8  set color of symbol and background the same
************************************************************************************/
void attr(void)
{
short att;
      get_exp(&att);
           putchar(27);
           putchar('[');
           putstr(int_to_str(att));
           putchar('m');
}
/************************************************************************************
Action:
Sets color attributes for console output
INK  sets the symbol color
PAPER  sets the background color
Syntax:
INK  expession 
PAPER  expession 

An expession defines the color
0  black
1  red
2  green
3  yellow
4  blue
5  magenta
6  cyan
7  white

Note. Using AT, CLS, ATTR, PAPER, INK allows change attributes on ANSI 
terminal, as console. Most terminals program can support this mode.
************************************************************************************/
void ink(void)
{
short att;
      get_exp(&att);
           putchar(27);
           putchar('[');
           putstr(int_to_str(att+30));
           putchar('m');
}

void paper(void)
{
short att;
      get_exp(&att);
           putchar(27);
           putchar('[');
           putstr(int_to_str(att+40));
           putchar('m');
}

/**********************************************************************************
Action:
BIN - puts to the console a value in BIN form. 
Function BIN is an elements of output list for PRINT operator.
:
PRINT [list1; or ,] BIN(value, digits)[; or , [list2]]

value  value or expression
digits  number of printed digits

Example:
REM ************************************
REM Prints value in bin format
REM ************************************
10 INPUT X
     PRINT X,BIN(X,16)
GOTO 10 
**********************************************************************************/

char putbin(unsigned short val,char digits)
{
char i = digits;
unsigned short mask = 0x8000;

   for(i=16;i>digits;i--)
             mask >>= 1;
   for(;i>0;i--)
       {
        if(val & mask) putchar('1');
         else putchar('0');
         mask >>= 1;
       }
return digits;
}
__flash char   hex_string[] = "0123456789ABCDEF";
puthexdigit(unsigned short val)
{
  val >>= 12;
  putchar(hex_string[val]);
}

char putbcd(unsigned short val,char digits)
{
   if((digits>0)&&(digits<5))
    {
     if(digits == 4) puthexdigit(val);
     val <<= 4;
     if(digits >= 3) puthexdigit(val);
     val <<= 4;
     if(digits >= 2) puthexdigit(val);
     val <<= 4;
     if(digits >= 1) puthexdigit(val);
    } else
       {
         putchar('*');
         putchar('*');
         putchar('*');
         putchar('*');
         return 4;
       }
return digits;
}

char puthex(unsigned short val,char digits)
{
return putbcd(val,digits);
}
/******************************************************************************************
Action:
Creates the block of a machine code at a stage of program loading.
Connects a code to a vector at a stage of execution.
If code of interrupt handler does not fit in one line, it is possible to continue in 
next line, but using INLINE operator. The line with INTERRUPT should be separated from 
other code by one of operators RETURN, GOTO as you need. At a stage of execution the line 
with INTERRUPT should be interpreted once for interrupti initialization. 
Requirements on registration of the block of a code same as well as for operator INLINE. 
Can be simultaneously used up to 10 vectors. It is impossible to set interruptions. 
For UART0 and TIMER0 as they are used by system. 
Syntax:
INTERRUPT vector, opcode1, opcode2.

Example1:
rem *****************************************
rem The simpliest case is when the handler 
rem takes only one line
rem *****************************************
INTERRUPT  vector, opcode1, opcode2 

Example2:

rem ***********************************************************
rem The operator INTERRUPT gets the start address of the code 
rem block and binds it with needed vector.
rem ***********************************************************
200  INTERRUPT  vector, opcode1, opcode2
         RETURN
         INLINE  opcoden, opcoden+1


******************************************************************************************/

void interrupt_exec(void)
{
char i;
PF tmp = int_dummy;
for(i=0;i<10;i++)
{
  if(vectors[i].func_ptr == tmp)
          break;
}
  if(i<10)
   {
    __disable_interrupt();
    vectors[i].func_ptr = (PF)(bas_int_number>>1);
    ndx_vectors[utmp8>>2] = i;
    __enable_interrupt();

   }
   else
    serror(20,1);
}
/******************************************************************************************
Action:
Disconnects the a handler code from vector and disables corresponding interrupt. 
Syntax:
DELETEVECTOR vector
******************************************************************************************/
void delete_vector(void)
{
unsigned char tmp8;
__disable_interrupt();
tmp8 = ndx_vectors[bas_int_number>>2];
ndx_vectors[bas_int_number>>2] = 255;
if(tmp8<10)
   vectors[tmp8].func_ptr = int_dummy;
__enable_interrupt();
}
/******************************************************************************************
Action:
Creates block of machine code on program downloading stage. A few lines of INLINE 
in any place of program create consequtive block of a code in special area of memory. 
If the block of a code is formed by several lines INLINE, it is necessary to take care, 
that interpreter will look only on first of them. The rest of INLINEs should be hidden 
after operators RETURN or GOTO.
The block of a code should be issued as the subroutine, last operator should 
be operator RET.
Communication with BASIC variables is simple, registers R16, R17 contain the pointer 
to variable A. A principle of formation of the address of any of 26 (from A up to Z) 
scalar variables following:
Address = value of R16R17 + 2 * (symbol code - 65) 


Syntax:
  INLINE opcode1, opcode2.
Example1: 
rem************************************
rem Simple case, code block is formed
rem by single operator INLINE
rem************************************
10  INLINE opcode1, opcode2.  
                               

Example2: 
rem **************************************************
rem Block of code is formed by two operators INLINE, 
rem so the second operator is hidden after RETURN. 
rem **************************************************
10  INLINE opcode1, opcode2.        
      RETURN                         
      INLINE opcoden, opcoden+1.    
******************************************************************************************/

void inline_exec(void)
{
PF pf;
  pf = (PF)(((unsigned short)bas_int_number) >> 1);
  pf(bas_variables);
}
#endif

/****************************************************
Action:
Puts a digital value out to the PWR channel
Syntax:
PWR pwm_pin, value 
****************************************************/
void dac(void)
{
short param1,param2,tmp;

   get_exp(&param1);
   get_token();
         if(*bas_token != ',')
                       serror(0,1);
   get_exp(&param2);
   tmp = param2 % 256;
   param2 >>= 8;

     if(param1 == 1) {OCR1AH  = param2; OCR1AL  = tmp;}
else if(param1 == 2) {OCR1BH  = param2; OCR1BL  = tmp;}
#ifdef MEGA64
else if(param1 == 3) {OCR1CH  = param2; OCR1CL  = tmp;}
#endif
else serror(19,1);
}


void adc(void)
{
short tmp,adc;
short *var;
tmp = ADCL;
adc = ADCH;
adc = (adc << 8) + tmp;

var = get_var(0);
*var = adc;
}

void delay_ms(short del)
{
    _CLI();
    delay_flag = 0;
    del_timer = del;
    _SEI();
    while(delay_flag == 0);
}


/****************************************************
Action:
Forms delay 1..65535 mSec 
Syntax:
DELAY expression
****************************************************/
void delay_(void)
{
short tmpu16;
   get_exp(&tmpu16);
   if(tmpu16)
     delay_ms(tmpu16);
}



void get_more_params(short *param_array,char n_param)
{
char i;
  get_exp(&(param_array[0])); 
  for(i=1;i<n_param;i++)
   { 
    get_token();
      if(*bas_token != ',')
                    serror(0,1);   
      get_exp(&(param_array[i])); 
   }

}
/****************************************************
Action:
Switches pin logic level to the inverted state
Syntax:
TOGGLE pin
****************************************************/ 
void toggle_bit(void)
{
short tmpu16;
     get_exp(&tmpu16);
       if(tmpu16 == 128)
        ADMUX ^= 0x01;
  else if(tmpu16 == 127)
              sound_flag ^= 0x01;
  else
    RAM_START[pio_table[tmpu16].out] ^= pio_table[tmpu16].mask;
}


/****************************************************
Action:
Opens a serial port
For IO_CONTROLLER_WITH_ATMEGA64  only
Syntax:
OPENSERIAL port,baudrate,txbuffer_size,rxbuffer_size
baudrate is the baudrate value devided by 100
for example for 57600 bps value should be 576
            for 19200 bps value should be 192
****************************************************/ 
#ifdef IO_CONTROLLER_WITH_ATMEGA64
void open_serial(void)
{
short params[4];
long baud_rate;

  get_more_params(params,2);

baud_rate = params[1];
baud_rate *= 100;
open_port(params[0], baud_rate, params[2], params[3]);
}

/****************************************************
Action:
Cloces an opened serial port, frees buffers
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
CLOSESERIAL port
****************************************************/ 
void close_serial(void)
{
short port;
   get_exp(&port);

close_port(port);

}

/****************************************************
Action:
Turns the LEDs on
For IO_CONTROLLER_WITH_ATMEGA64
Syntax:
LEDON led_number
****************************************************/ 
void led_on(void)
{
short led;
   get_exp(&led);
   if((led>=0)&&(led<4))
    {
      led += 4;
      PORTE &= ~(1<<led);
    }
}
/****************************************************
Action:
Turns the LEDs off
For IO_CONTROLLER_WITH_ATMEGA64
Syntax:
LEDOFF led_number
****************************************************/ 
void led_off(void)
{
short led;
   get_exp(&led);
 if((led>=0)&&(led<4))
    {
      led += 4;
      PORTE |= (1<<led);
    }
}
/****************************************************
Action:
Switches the LEDs to the inverted state
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
LEDTOGGLE led_number
****************************************************/ 

void led_toggle(void)
{
short led;
   get_exp(&led);
   if((led>=0)&&(led<4))
    {
      led += 4;
      PORTE ^= (1<<led);
    }
}
/****************************************************
Action:
Turns the discrete output on
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
DISCRETEON output_number
****************************************************/ 
void discrete_on(void)
{
short dout;
   get_exp(&dout);
   if((dout>=0)&&(dout<4))
    {
      dout += 4;
      PORTB |= (1<<dout);
    }
  else if((dout>=4)&&(dout<8))
    {
      PORTD |= (1<<dout);
    }
}
/****************************************************
Action:
Turns the discrete output off
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
DISCRETEOFF output_number
****************************************************/ 
void discrete_off(void)
{
short dout;
   get_exp(&dout);
   if((dout>=0)&&(dout<4))
    {
      dout += 4;
      PORTB &= ~(1<<dout);
    }
 else if((dout>=4)&&(dout<8))
    {
      PORTD &= ~(1<<dout);
    }
}

/****************************************************
Action:
Outputs value to the discrete outputport 
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
DISCRETEOUTPUT val
****************************************************/ 
void discrete_output(void)
{
short dout;
   get_exp(&dout);
PORTB = (PORTB & 0x0F) | ((dout << 4) & 0xF0);
PORTD = (PORTD & 0x0F) | (dout & 0xF0);
}

/****************************************************
Action:
Switches the discrete output to the inverted state
For IO_CONTROLLER_WITH_ATMEGA64 only
Syntax:
DISCRETETOGGLE output_number
****************************************************/ 
void discrete_toggle(void)
{
short dout;
   get_exp(&dout);
   if((dout>=0)&&(dout<4))
    {
      dout += 4;
      PORTB ^= (1<<dout);
    }
  else if((dout>=4)&&(dout<8))
    {
      PORTD ^= (1<<dout);
    }
}

void preset_IO(void)
{
DDRA = 0x00;   PORTA = 0xFF;
PORTB &= 0x0F; DDRB |= 0xF0;
PORTD &= 0x0F; DDRD |= 0xF0;
PORTE |= 0xF0; DDRE |= 0xF0;
PORTC = 0xFF; DDRC = 0x00;

          DDRF &= 0xF0;
          PORTF &= 0xF0;
          ADCSR  = (1 << ADEN) + (1 << ADFR) + 5;
          ADCSR  |= (1 << ADSC);
}




#endif
/****************************************************
Action:
Sets pin logic level to one
Syntax:
SETBIT pin 
****************************************************/
void set_bit(void)
{
short tmpu16;
  get_exp(&tmpu16);
  RAM_START[pio_table[tmpu16].out] |= pio_table[tmpu16].mask;
}

/****************************************************
Action:
Sets pin logic level to zero
Syntax:
CLEARBIT pin 
****************************************************/
void clr_bit(void)
{
short tmpu16;
  get_exp(&tmpu16);
  RAM_START[pio_table[tmpu16].out] &= ~pio_table[tmpu16].mask;
}
