/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"

__flash char _clr_screen_[] = "\x01B[1;36;44m\x01B[2J";
__flash char _bas_int_[] = "BASINT ";
__flash char _ver_[] = __FW_VERSION__;
__flash char _tbc_group_[] = "                TBC Group 2006";
__flash char _program_area_[] = "\r\nProgram area ";
__flash char _bytes_[] = " bytes";
__flash char _line_[] = "\r\n_________________________________________";
__flash char _ground_protect_[] = "\r\nGround protect pin to disable this screen\r\n";
__flash char _white_on_black_[] = "\x01B[1;37;40m";
__flash char _cyan_on_blue_[] = "\x01B[1;36;44m";
__flash char _gray_on_blue_[] = "\x01B[0;37;44m";
__flash char _white_on_blue_[] = "\x01B[1;37;44m";
__flash char _list_[] = "-List ";
__flash char _load_[] = "-Load ";
__flash char _run_[] = "-Run ";
__flash char _about_[] = "-About ";
__flash char _reflash_[] = "\r\nReflash\r\n";
__flash char _ok_[] = "\r\nOK";
unsigned char *prog_buffer;
unsigned char *code_buf_ptr;
unsigned char *code_buffer;
char sound_flag = 1;
volatile short del_timer = (short)bas_program;
volatile char delay_flag = 0;
void interpreter_main(void);
int  putchar(int c);
unsigned char keep_alive_timer = 0;
unsigned char flash_flag = 0;
VECTOR vectors[10];
unsigned char ndx_vectors[34];

#define TDELAY 5 /* 500 uS */
#define T0_VALUE  (256 - (FOSC * TDELAY)/640000)
void preset_IO(void);
unsigned char int_ndx;
void int_dummy(short *tmp)
{

}
void int_routine(void)
{
unsigned ndx = ndx_vectors[int_ndx];
if (ndx > 9) return;
  vectors[ndx].func_ptr(bas_variables);
}

__flash char   _press_any_[] = "\r\n\r\nPress any key to continue...\r\n";
void press_any_key(void)
{
putstr_P(_press_any_);
if(getchar()==0x0D)
                getchar();
}

void int_init(void)
{
unsigned char i;

for(i=0;i<10;i++)
   vectors[i].func_ptr = int_dummy;
for(i=0;i<34;i++)
   ndx_vectors[i] = 0;
#ifdef MEGA64
ndx_vectors[USART0_RXC_vect>>2] = 255;
ndx_vectors[USART0_UDRE_vect>>2]= 255;
ndx_vectors[USART0_TXC_vect>>2] = 255;
#endif

#ifdef MEGA32
ndx_vectors[USART_RXC_vect>>2] = 255;
ndx_vectors[USART_UDRE_vect>>2]= 255;
ndx_vectors[USART_TXC_vect>>2] = 255;
#endif

#ifdef MEGA16
ndx_vectors[USART_RXC_vect>>2] = 255;
ndx_vectors[USART_UDRE_vect>>2]= 255;
ndx_vectors[USART_TXC_vect>>2] = 255;
#endif

ndx_vectors[TIMER0_COMP_vect>>2] = 255;
ndx_vectors[TIMER0_OVF_vect>>2] = 255;

}

#define SET_VECTOR(vec)\
__interrupt void int_handle_ ## vec(void) { int_ndx = vec>>2; int_routine();}

#pragma vector = INT0_vect
SET_VECTOR(INT0_vect);
#pragma vector = INT1_vect
SET_VECTOR(INT1_vect);
#pragma vector = INT2_vect
SET_VECTOR(INT2_vect);
#ifdef MEGA64
#pragma vector = INT3_vect
SET_VECTOR(INT3_vect);
#pragma vector = INT4_vect
SET_VECTOR(INT4_vect);
#pragma vector = INT5_vect
SET_VECTOR(INT5_vect);
#pragma vector = INT6_vect
SET_VECTOR(INT6_vect);
#pragma vector = INT7_vect
SET_VECTOR(INT7_vect);
#endif
#pragma vector = TIMER2_COMP_vect
SET_VECTOR(TIMER2_COMP_vect);
#pragma vector = TIMER2_OVF_vect
SET_VECTOR(TIMER2_OVF_vect);
#pragma vector = TIMER1_CAPT_vect
SET_VECTOR(TIMER1_CAPT_vect);
#pragma vector = TIMER1_COMPA_vect
SET_VECTOR(TIMER1_COMPA_vect);
#pragma vector = TIMER1_COMPB_vect
SET_VECTOR(TIMER1_COMPB_vect);
#pragma vector = TIMER1_OVF_vect
SET_VECTOR(TIMER1_OVF_vect);
//#pragma vector = TIMER0_COMP_vect
//SET_VECTOR(TIMER0_COMP_vect);
//#pragma vector = TIMER0_OVF_vect
//SET_VECTOR(TIMER0_OVF_vect);
#pragma vector = SPI_STC_vect
SET_VECTOR(SPI_STC_vect);
//#pragma vector = USART0_RXC_vect
//SET_VECTOR(USART0_RXC_vect);
//#pragma vector = USART0_UDRE_vect
//SET_VECTOR(USART0_UDRE_vect);
//#pragma vector = USART0_TXC_vect
//SET_VECTOR(USART0_TXC_vect);
#pragma vector = ADC_vect
SET_VECTOR(ADC_vect);
#pragma vector = EE_RDY_vect
SET_VECTOR(EE_RDY_vect);
#pragma vector = ANA_COMP_vect
SET_VECTOR(ANA_COMP_vect);

#ifdef MEGA64
#pragma vector = TIMER1_COMPC_vect
SET_VECTOR(TIMER1_COMPC_vect);
#pragma vector = TIMER3_CAPT_vect
SET_VECTOR(TIMER3_CAPT_vect);
#pragma vector = TIMER3_COMPA_vect
SET_VECTOR(TIMER3_COMPA_vect);
#pragma vector = TIMER3_COMPB_vect
SET_VECTOR(TIMER3_COMPB_vect);
#pragma vector = TIMER3_COMPC_vect
SET_VECTOR(TIMER3_COMPC_vect);
#pragma vector = TIMER3_OVF_vect
SET_VECTOR(TIMER3_OVF_vect);
#endif

//#pragma vector = USART1_RXC_vect
//SET_VECTOR(USART1_RXC_vect);
//#pragma vector = USART1_UDRE_vect
//SET_VECTOR(USART1_UDRE_vect);
//#pragma vector = USART1_TXC_vect
//SET_VECTOR(USART1_TXC_vect);
#ifdef MEGA64
#pragma vector = TWI_vect
SET_VECTOR(TWI_vect);
#endif

#ifdef MEGA32
#pragma vector = TWSI_vect
SET_VECTOR(TWSI_vect);
#endif

#ifdef MEGA16
#pragma vector = TWI_vect
SET_VECTOR(TWI_vect);
#endif



#pragma vector = SPM_RDY_vect
SET_VECTOR(SPM_RDY_vect);

void  cr_lf(void)
{
  putchar(0x0D);
  putchar(0x0A);
}


int get_start_basic_area(void)
{
int delta;
int start_raw = (int)__segment_begin("BASIC_PROGRAM");
  if((delta = start_raw % BYTES_FLASH_PSIZE) != 0)
       start_raw += (BYTES_FLASH_PSIZE - delta);
return start_raw;

}
#pragma vector = TIMER0_OVF_vect
__interrupt void TIMER0_ovf(void)
{
 TCNT0 = T0_VALUE;
if(keep_alive_timer)
  {
   keep_alive_timer--;
   if(keep_alive_timer == 0)
        LED_RUN_OFF();
  }
   if(del_timer)
   {
      del_timer--;
      if(del_timer == 0)
         delay_flag = 1;
   }
}



int wait_symbol(int del)
{
int ch;

  for(del_timer = del; del_timer != 0; )
  {
   ch = get_char();
         if(ch != -1)
             return ch;
  }
return -1;
}

short get_adc(void)
{
short tmp,adc;
tmp = ADCL;
adc = ADCH;
adc = (adc << 8) + tmp;
return adc;
}



void load_program(void)
{
unsigned char *buf;
char i,cnt,crlf;
unsigned long blk;
short ch;
int del = 32767;
int offset;
char ibuf[80];
char obuf[80];
unsigned long page;
putstr_P(_reflash_);
clear_label_table();
blk = START_BASIC_PROGRAM / BYTES_FLASH_PSIZE;
  buf = (unsigned char*)START_BUF;
  i = 0;
  prog_ndx = 0;
  crlf = 0;
  cur_line = 0;
  while(get_char() != -1);
  while(1)
  {
    if((ch = wait_symbol(del)) != -1)
    {
      ibuf[i++] = ch;
      if((ch == 0x0D) || (ch == 0x0A)) crlf++;
       if(crlf>1)
         {
            ibuf[i] = 0x00;
            cur_line++;
            cnt = convert_line_to_intformat(prog_ndx, obuf, ibuf) - obuf;
            prog_ndx += cnt;
              for(i = 0; i < cnt; i++)
              buf = flash_byte(buf,&blk,obuf[i]);
              i=0;
              crlf = 0;
          }
       del = 500;
    }
      else
    {
       if(i)
       {
        ibuf[i] = 0x00;
        cur_line++;
        cnt = convert_line_to_intformat(prog_ndx, obuf, ibuf) - obuf;
        prog_ndx += cnt;

         for(i = 0; i < cnt; i++)
          buf = flash_byte(buf,&blk,obuf[i]);
         i=0;
        crlf = 0;
       }

       buf = flash_byte(buf,&blk,0x0D);
       buf = flash_byte(buf,&blk,0x00);
       buf = flash_byte(buf,&blk,0x00);
       if((unsigned char*)buf - (unsigned char*)START_BUF)
FlashPage(blk,START_BUF,(unsigned char*)buf - (unsigned char*)START_BUF);


offset = 0;
blk=0;
for(i=LABEL_BUFFER_SIZE / BYTES_FLASH_PSIZE; i !=0; i--)
{
FlashPage( LABEL_TABLE / BYTES_FLASH_PSIZE + blk,(unsigned char*)label_table + offset,BYTES_FLASH_PSIZE);
offset += BYTES_FLASH_PSIZE;
blk++;
}
page = page;
#ifdef MAXI_SYSTEM
offset = 0;
blk=0;
for(i = (char)(INLINE_CODE_SIZE / BYTES_FLASH_PSIZE); i !=0; i--)
{
page = START_OF_INLINE_CODE;
page /= BYTES_FLASH_PSIZE;
FlashPage(page + blk,(unsigned char*)code_buffer,BYTES_FLASH_PSIZE);
offset += BYTES_FLASH_PSIZE;
blk++;
}
#endif
       putstr_P(_ok_);
       break;
    }
  }
}


void show_highlighted_symbol(char digit)
{
putstr_P(_white_on_black_);
putchar(' ');
putchar(digit);
putchar(' ');
putstr_P(_cyan_on_blue_);
}

void show_title(void)
{
putstr_P(_clr_screen_);
putstr_P(_bas_int_);putstr_P(_ver_);putstr_P(_tbc_group_);
putstr_P(_program_area_);
#ifdef MAXI_SYSTEM
abs_to_str(SIZE_OF_BASIC_PROGRAM - 3);
#else
putstr(int_to_str(SIZE_OF_BASIC_PROGRAM - 3));
#endif
putstr_P(_bytes_);
putstr_P(_white_on_blue_);putstr_P(_line_); cr_lf();cr_lf();
show_highlighted_symbol('1');putstr_P(_list_);
show_highlighted_symbol('2');putstr_P(_load_);
show_highlighted_symbol('3');putstr_P(_run_);
//show_highlighted_symbol('4');putstr_P(_about_);
putstr_P(_white_on_blue_);putstr_P(_line_);
putstr_P(_cyan_on_blue_);
putstr_P(_ground_protect_);
}



void main(void)
{
int ch = 0;
PF restart=0;
//----------------------------------
// TIMER0 init
//----------------------------------
 _CLI();
  TCNT0 = T0_VALUE;      // 1 mS
  TIMSK = TIMSK | 1;
  TCCR0 = 0x03;
  UBRRH = 0;

   TCNT1H = 0;
   TCNT1L = 0;

   OCR1AH  = (0);
   OCR1AL  = (0);
   TCCR1A = (1 << COM1A1) + (1 << WGM10) + (1 << WGM11);
   TCCR1B = (1 << CS10) + (0 << WGM12) + (0 << WGM13);

   TIFR |= (1 << OCF1A);
   TIFR |= (1 << TOIE1);

    ADMUX = 0x00;

  LED_RUN_INIT();
  PROTECT_PIN_INIT();
  CTS_INIT();
  CTS_HIGH();

#ifdef IO_CONTROLLER_WITH_ATMEGA64
       open_port(0, 57600,64, 64);
#else
              UBRRL = br9600;        // set Baud rate
              UCSRB = 0x98;           // enable uart receive + transmit + rxc interrupt
#endif


int_init();

_SEI();

memcpy_P((unsigned char*)label_table,(__flash char*)(LABEL_TABLE),LABEL_BUFFER_SIZE);

#ifdef IO_CONTROLLER_WITH_ATMEGA64
   preset_IO();
#endif


if(PROTECT_PIN())
{
show_title();

while(1)
{
ch = getchar();

if(ch == '2')
  {
    prog_buffer = malloc(PROG_BUFFER_SIZE);
    memset(prog_buffer,255,PROG_BUFFER_SIZE);
    bas_token_ext = malloc(80);
#ifdef MAXI_SYSTEM
    code_buffer = malloc(INLINE_CODE_SIZE);
    memset(code_buffer,255,INLINE_CODE_SIZE);
    code_buf_ptr = code_buffer;
#endif
    flash_flag = 0x55;
    load_program();
    flash_flag = 0x00;
    press_any_key();
    restart(0);
  }
else if(ch == '1')
    {
    listing_restore();
    restart(0);
    }
 else if(ch == '3')
    goto label_run;
}
}
label_run:
   bas_fstack  = malloc(sizeof(FOR_STACK) *FOR_NEST);
   bas_variables = malloc(sizeof(ARITH_BASE) * 26);
   array_table   = malloc(sizeof(ARRAY_ELEMENT) * 26);
   bas_gstack = malloc(sizeof(char __flash*) * SUB_NEST);
   interpreter_main();
}
