/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#ifndef __HWDEF_H__
#define __HWDEF_H__


#ifdef IO_CONTROLLER_WITH_ATMEGA64

#define FOSC   14745600

#define LED_RUN_INIT()    { DDRE |= 0xF0; PORTE |= 0xF0; }
#define INPUT_INIT()      { DDRC = 0x00; PORTC = 0xFF; }
#define LED1_4_INIT()     { DDRD |= 0xF0; PORTD &= ~0xF0;}


#define LED_RUN_ON()       PORTE &= ~(1 << PE7)
#define LED_RUN_OFF()      PORTE |= (1 << PE7)

#define CTS_INIT()         DDRD |= (1 << PD3)
#define CTS_LOW()          PORTD |= (1 << PD3)
#define CTS_HIGH()         PORTD &= ~(1 << PD3)

#define PROTECT_PIN_INIT() {PORTA |= (1 << PA0);DDRA &= (1 << PA0);}
#define PROTECT_PIN()      (PINA & (1 << PA0))


#endif


#ifdef DBOARD_40PIN_MEGA32

//#define FOSC   14745600
#define FOSC   8000000

#define LED_RUN_INIT()       { DDRC |= (1 << PC7); PORTC |= (1 << PC7); }
#define LED_RUN_ON()          PORTC &= ~(1 << PC7)
#define LED_RUN_OFF()         PORTC |= (1 << PC7)

#define CTS_INIT()          DDRD |= (1 << PD2)
#define CTS_LOW()           PORTD |= (1 << PD2)
#define CTS_HIGH()          PORTD &= ~(1 << PD2)

#define PROTECT_PIN_INIT()  {PORTC |= (1 << PC6);DDRC &= ~(1 << PC6);}
#define PROTECT_PIN()       (PINC & (1 << PC6))

#endif

#ifdef DBOARD_40PIN_MEGA16

//#define FOSC   14745600
#define FOSC      8000000



#define LED_RUN_INIT()       { DDRC |= (1 << PC7); PORTC |= (1 << PC7); }
#define LED_RUN_ON()          PORTC &= ~(1 << PC7)
#define LED_RUN_OFF()         PORTC |= (1 << PC7)

#define CTS_INIT()          DDRD |= (1 << PD2)
#define CTS_LOW()           PORTD |= (1 << PD2)
#define CTS_HIGH()          PORTD &= ~(1 << PD2)

#define PROTECT_PIN_INIT()  {PORTC |= (1 << PC6);DDRC &= ~(1 << PC6);}
#define PROTECT_PIN()       (PINC & (1 << PC6))

#endif



#define br4800       (FOSC/16/4800 - 1)
#define br9600       (FOSC/16/9600 - 1)
#define br19200      (FOSC/16/19200 - 1)
#define br38400      (FOSC/16/38400 - 1)
#define br57600      (FOSC/16/57600 - 1)




#endif
