/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/

#ifndef __INCLUDES_H__
#define __INCLUDES_H__

#pragma segment="BASIC_PROGRAM"
#pragma segment="FL_UTIL"

#ifdef MEGA128
#define PROG_BUFFER_SIZE  256
#define INLINE_CODE_SIZE 1024+512
#define LABEL_BUFFER_SIZE 768
#endif

#ifdef MEGA64
#define PROG_BUFFER_SIZE  256
#define INLINE_CODE_SIZE 1024+512
#define LABEL_BUFFER_SIZE 768
#endif

#ifdef MEGA32
#define PROG_BUFFER_SIZE  128
#define INLINE_CODE_SIZE 256
#define LABEL_BUFFER_SIZE 256
#endif

#ifdef MEGA16
#define PROG_BUFFER_SIZE  128
#define INLINE_CODE_SIZE  PROG_BUFFER_SIZE
#define LABEL_BUFFER_SIZE PROG_BUFFER_SIZE
#endif

//#define FOSC 14745600


void int_dummy(short *tmp);
int get_start_basic_area(void);
extern char __flash bas_program[];
extern char access_enabled;
extern unsigned char keep_alive_timer;
extern volatile char delay_flag;
#define START_BUF prog_buffer
#define  LABEL_TABLE       get_start_basic_area()
#define  START_BASIC_PROGRAM  (LABEL_TABLE + NUM_LAB * 4)

#ifdef MAXI_SYSTEM
#define SIZE_OF_BASIC_PROGRAM ((int)__segment_begin("FL_UTIL") - START_BASIC_PROGRAM - INLINE_CODE_SIZE)
#else
#define SIZE_OF_BASIC_PROGRAM ((int)__segment_begin("FL_UTIL") - START_BASIC_PROGRAM)
#endif


#define START_OF_INLINE_CODE ((unsigned long)__segment_begin("FL_UTIL") - INLINE_CODE_SIZE)

extern unsigned char *prog_buffer;//[PROG_BUFFER_SIZE];
extern unsigned char *code_buf_ptr;
extern unsigned char *code_buffer;//[PROG_BUFFER_SIZE];
extern volatile short del_timer;
extern char sound_flag;
int  getchar(void);
int  putchar(int c);
void delay_ms(short del);
void press_any_key(void);
void  cr_lf(void);
short find_fix_label_by_ndx(short ndx);



#define MT_SLA_ACK  0x18
#define MT_DATA_ACK 0x28
#define M_START     0x08
#define MR_SLA_ACK  0x40
#define MR_DATA_ACK 0x28


#ifdef MEGA8
#include <iom8.h>
#endif

#ifdef MEGA16
#include <iom16.h>
#define ADFR  5
#define ADCSR   ADCSRA
#endif


#ifdef MEGA64
#include <iom64.h>
#define UBRRH  UBRR0H
#define UBRRL  UBRR0L
#define UCSRB  UCSR0B
#define UDR    UDR0
#define UCSRA  UCSR0A
#define TXC   TXC0
#define USART_RXC_vect USART0_RXC_vect
#define ADFR  5
#define ADCSR   ADCSRA
#endif

#ifdef MEGA128
#include <iom128.h>
#define UBRRH  UBRR0H
#define UBRRL  UBRR0L
#define UCSRB  UCSR0B
#define UDR    UDR0
#define UCSRA  UCSR0A
#define TXC   TXC0
#define USART_RXC_vect USART0_RXC_vect
#define ADFR  5
#define ADCSR   ADCSRA
#endif

#ifdef MEGA32
#include <iom32.h>
#define ADFR  5
#define ADCSR   ADCSRA
#endif

#include <ina90.h>
#include <pgmspace.h>

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#ifdef IO_CONTROLLER_WITH_ATMEGA64
#include "scomdriv.h"
#else
#include "serial.h"
#endif


#include "version.h"
#include "hwdef.h"
#include "utils.h"
#include "flash.h"
#include "interpreter.h"
//#include "add_operators.h"
#include "symlcd.h"
#include "cmdnfunc.h"
extern VECTOR vectors[10];
extern unsigned char ndx_vectors[34];


#endif
