/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"

char *bas_prog;  /* holds expression to be analyzed */
char __flash  *bas_prog_int;  /* holds expression to be analyzed */
char __flash  *data_pointer;  /* holds expression to be analyzed */

ARITH_BASE *bas_variables;//[26];
ARRAY_ELEMENT *array_table;//[26];
char *bas_token_ext;//[64];
FIX_LABEL label_table[NUM_LAB];
FOR_STACK *bas_fstack;//[FOR_NEST]; /* stack for FOR/NEXT loop */
char __flash **bas_gstack;//[SUB_NEST];	/* stack for gosub */
char look_up_opr(char *s);
char __flash *bas_token;
char bas_token_type;
char bas_tok;
char last_token_len = 0;
ARITH_BASE bas_int_number;
unsigned char utmp8;
short cur_line;
char last_error;
int bas_ftos;  /* index to top of FOR stack */
int bas_gtos;  /* index to top of GOSUB stack */
char cur_channel = 0;

__flash char _stopped_string_[] =  "\r\n********  STOP AT LINE: ";
__flash char _cls_string_[] =  "\x01B[0m\x01B[2J";


void interpreter_main(void)
{
char i;
  last_error = 0;
  bas_prog_int = (__flash char*)( START_BASIC_PROGRAM);
  bas_ftos = 0; /* initialize the FOR stack index */
  bas_gtos = 0; /* initialize the GOSUB stack index */
  data_pointer = (__flash char*)( START_BASIC_PROGRAM);
  find_data_block();

  for(i = 0; i < 26; i++)
   {
    array_table[i].size = 0;
    array_table[i].start = 0;
    bas_variables[i] = 0;
   }

  do {
    keep_alive_timer = 250;
    LED_RUN_ON();
    bas_token_type = get_token();
    /* check for assignment statement */

    if(bas_token_type==VARIABLE) {
      bas_prog_int -= last_token_len; /* return the var to the input stream */
      assignment(); /* must be assignment statement */
    }
else if(bas_token_type==FUNC) {
     bas_functions(bas_tok);

    }
    else /* is command */
      {

        if(bas_tok == STOP)
             {
                while(get_char() != -1);
                putstr_P(_stopped_string_);
                putstr(int_to_str(get_line_number(bas_prog_int)+1));
                getchar();
             }

      switch(bas_tok) {
#ifdef MAXI_SYSTEM
   case INTERRUPT:
        interrupt_exec();
    break;
   case INLINE:
        inline_exec();
    break;
   case DELETEVECTOR:
        delete_vector();
      break;
    case ENABLE:
       __enable_interrupt();
      break;
    case DISABLE:
       __disable_interrupt();
      break;
    case ATTR:
        attr();
      break;
    case PAPER:
        paper();
      break;
    case INK:
        ink();
      break;
        case CLS:
           putstr_P(_cls_string_);
        break;
        case LCDINIT:
           lcdinit_exec();
        break;
        case KEYINIT:
           keyinit_exec();
        break;
#endif

#ifdef IO_CONTROLLER_WITH_ATMEGA64
      case OPENSERIAL:
           open_serial();
        break;
      case CLOSESERIAL:
           close_serial();
        break;
      case LEDON:
           led_on();
        break;
      case LEDOFF:
           led_off();
        break;
      case LEDTOGGLE:
           led_toggle();
        break;
      case DISCRETEON:
           discrete_on();
        break;
      case DISCRETEOFF:
           discrete_off();
        break;
      case DISCRETETOGGLE:
           discrete_toggle();
        break;
      case DISCRETEOUTPUT:
           discrete_output();
        break;
#endif
          case REM:
           bas_prog_int++;
           bas_prog_int += *bas_prog_int;
	  break;
        case NORM:
          scale();
	  break;
        case SETBIT:
          set_bit();
	  break;
        case CLEARBIT:
          clr_bit();
	  break;
        case DELAY:
          delay_();
	  break;
        case ADC:
          adc();
	  break;
        case DAC:
          dac();
	  break;
        case PRINT:
	  print();
  	  break;
        case GOTO:
	  exec_goto();
	  break;
	case IF:
	  exec_if();
	  break;
	case FOR:
	  exec_for();
	  break;
	case NEXT:
	  next();
	  break;
  	case INPUT:
	  input_();
	  break;
        case GOSUB:
	  gosub();
	  break;
	case RETURN:
	  greturn();
	  break;
	case DIM:
          exec_dim();
	  break;
	case DATA:
        case ELSE:
        find_eol();
	break;
	case READ:
          exec_read();
	break;
	case RESTORE:
          exec_restore();
        break;
        case POKE:
          poke();
        break;
        case DEFPIN:
          defpin();
        break;
        case WRITEEEPROM:
          write_eeprom();
        break;
   case SETADMUX:
      setadmux();
    break;
   case ROL:
        rol();
    break;
   case ROR:
        ror();
    break;
    case PULSEOUT:
       pulseout();
      break;
    case SHIFTOUT:
        shift_out();
      break;
    case TOGGLE:
         toggle_bit();
      break;
    case PUTATOMIC:
      put_atomic();
      break;
//    case BITWAIT:
//      break;
    case TWISTART:
        twistart();
      break;
    case TWISTOP:
        twistop();
      break;
    case TWIWRITE:
        twiwrite();
      break;
    case TWIINIT:
        twiinit();
      break;
    case END:
      stop_executive();
      }
     }
  } while (bas_tok != FINISHED);
stop_executive();
}


/* Assign a variable a value. */
void assignment(void)
{
  ARITH_BASE var, value;
 short ndx;
  /* get the variable name */
  get_token();
  if(bas_token_type != VARIABLE)
    serror(4,1);

  var = bas_tok;

  /* get the equals sign */
  get_token();

if(*bas_token == '=')
{
  /* get the value to assign to var */
  get_exp(&value);
  /* assign the value */
  bas_variables[var] = value;
} else if(*bas_token == '(')
  {

     get_exp(&ndx);
     if(array_table[var].size == 0)
        serror(14,1);
     if(ndx >= array_table[var].size)
        serror(17,1);

     get_token();
     if(*bas_token!=')')
                 serror(0,1);
       get_token();
       if(*bas_token == '=')
       {
         get_exp(&value);
         array_table[var].start[ndx] = value;
       } else
           serror(3,1);
  }
   else
     serror(3,1);
}
/* Execute a simple version of the BASIC PRINT statement */
void print()
{
  ARITH_BASE answer;
  int len=0, spaces;
  char last_delim;
  char first_char;
  do {
    get_token(); /* get next list item */

    if( bas_tok==EOL) break;
    if( bas_tok==FINISHED) break;
    if(bas_token_type==DELIMITER && *bas_token==':') break;
    if((bas_token_type == COMMAND)&&(bas_tok == ELSE)){ find_eol();break;}

    if(bas_token_type==QUOTE) { /* is string */
      first_char = *bas_token;
      if(first_char != '$')
      {
      putstr_P(bas_token);
      len += strlen_P(bas_token);
      }
      get_token();

    }
    else
      {

      bas_prog_int -= last_token_len;
      get_token();

      if((bas_token_type==FUNC)&&(
                                   (bas_tok==CHR)
                                 #ifdef MAXI_SYSTEM
                                || (bas_tok==AT)||
                                   (bas_tok==BIN)||
                                   (bas_tok==HEX)||
                                   (bas_tok==BCD)||
                                   (bas_tok==CHN)
                                 #endif
           )
         )
         len += bas_functions(bas_tok);
    else

    {
      /* is expression */
      bas_prog_int -= last_token_len;
      get_exp(&answer);
      len += putstr(int_to_str(answer));
    }

      get_token();
   }



    last_delim = *bas_token;

    if(*bas_token==',') {
      /* compute number of spaces to move to next tab */
      spaces = 8 - (len % 8);
      len += spaces; /* add in the tabbing position */
      while(spaces) {
               putchar(' ');
               spaces--;
      }
    }
    else if(*bas_token==';') /* do nothing */;
    else if(*bas_token==':') break;
    else if((bas_token_type == COMMAND)&&(bas_tok == ELSE)) find_eol();
    else if(bas_tok!=EOL && bas_tok!=FINISHED) serror(0,1);
  } while (*bas_token==';' || *bas_token==',');

  if(bas_tok==EOL || bas_tok==FINISHED || *bas_token==':') {
    if(last_delim != ';' && last_delim!=',')
                                         cr_lf();
  }
  else serror(0,1); /* error is not , or ; */

}





void find_eol()
{
  while(!((bas_token_type == DELIMITER) && (bas_tok == EOL)))
   {
     if ((bas_token_type==COMMAND) && (bas_tok == REM))
        {
          bas_prog_int++;
          bas_prog_int += *bas_prog_int;
        }
     get_token();
   }

  bas_prog_int--;

}

/* Execute a GOTO statement. */
void exec_goto()
{

  short loc;

  get_token(); /* get label to go to */
  /* find the location of the label */
    if((loc = label_table[bas_int_number].prog_ndx) == -1)

    serror(7,1); /* label not defined */

  else bas_prog_int = (__flash char*)( START_BASIC_PROGRAM) + loc;  /* start program running at that loc */
}

/* Execute an IF statement. */
void exec_if()
{
  ARITH_BASE x , y;
  char op1,op2, cond;

  get_exp(&x); /* get left expression */

  get_token(); /* get the operator */
  if(!strchr("=<>", bas_token[0])) {

    serror(0,1); /* not a legal operator */
    return;
  }
  op1=*bas_token;
  if(strchr("=<>", bas_token[1]))
   {
     get_token();
     op2=*bas_token;
   }
    else
      op2=0;

  get_exp(&y); /* get right expression */

  /* determine the outcome */
  cond = 0;
  switch(op1) {
    case '<':
        if(op2==0)  { if(x<y)  cond=1; }
   else if(op2=='>'){ if(x!=y) cond=1; }
   else if(op2=='='){ if(x<=y) cond=1; }
     break;
    case '>':

        if(op2==0)  { if(x>y)  cond=1; }
   else if(op2=='<'){ if(x!=y) cond=1; }
   else if(op2=='='){ if(x>=y) cond=1; }

      break;
    case '=':
        if(op2==0)  { if(x==y) cond=1; }
   else if(op2=='<'){ if(x<=y) cond=1; }
   else if(op2=='>'){ if(x>=y) cond=1; }
      break;
  }
  if(cond) { /* is true so process target of IF */
    get_token();
    if(bas_tok!=THEN) {
      serror(8,1);
      return;
    }/* else program execution starts on next line */
  }
  else
  {
     while(1)
     {
       if((bas_token_type == DELIMITER) && (bas_tok == EOL)) break;
       if((bas_token_type == COMMAND) && (bas_tok == ELSE)) break;
        get_token();
     }
  bas_prog_int--;
        //find_eol(); /* find start of next line */

  }
}

/* Execute a FOR loop. */
void exec_for()
{
  FOR_STACK i;
  ARITH_BASE value;

  get_token(); /* read the control variable */
  if(bas_token_type != VARIABLE)
                        serror(4,1);

  i.var = bas_tok; /* save its index */

  get_token(); /* read the equals sign */
  if(*bas_token!='=') {
    serror(3,1);
    return;
  }


  get_exp(&value); /* get initial value */

  bas_variables[i.var]=value;

  get_token();
  if(bas_tok!=TO) serror(9,1); /* read and discard the TO */

  get_exp(&i.target); /* get target value */

  /* if loop can execute at least once, push info on stack */
  if(value>=bas_variables[i.var]) {
    i.loc = bas_prog_int;
    fpush(i);
  }
  else  /* otherwise, skip loop code altogether */
    while(bas_tok!=NEXT) get_token();
}

/* Execute a NEXT statement. */
void next()
{
  FOR_STACK i;

  i = fpop(); /* read the loop info */

  bas_variables[i.var]++; /* increment control variable */
  if(bas_variables[i.var]>i.target) return;  /* all done */
  fpush(i);  /* otherwise, restore the info */
  bas_prog_int = i.loc;  /* loop */
}

/* Push function for the FOR stack. */
void fpush(FOR_STACK i)

{
   if(bas_ftos>FOR_NEST)
    serror(10,1);

  bas_fstack[bas_ftos]=i;
  bas_ftos++;
}

FOR_STACK fpop(void)
{
  bas_ftos--;
  if(bas_ftos<0) serror(11,1);
  return(bas_fstack[bas_ftos]);
}

/* Execute a simple form of the BASIC INPUT command */
void input_()
{
short *var;
  int i;
  char *wp;
  get_token(); /* see if prompt string is present */
  if(bas_token_type==QUOTE) {
    putstr_P(bas_token); /* if so, print it and check for comma */
    get_token();
    if(*bas_token!=',') serror(1,1);
  }
    else
      {
       putstr("? "); /* otherwise, prompt with / */
       bas_prog_int -= last_token_len;
      }
    var = get_var(0);
    wp = input_line();
    i = atoi(wp);
    *var = i; /* store it */
    cr_lf();


}

/* Execute a GOSUB command. */
void gosub(void)
{
  short loc;

  get_token();

  if((loc = label_table[bas_int_number].prog_ndx) == -1)
    serror(7,1); /* label not defined */
  else {
    gpush(bas_prog_int); /* save place to return to */
    bas_prog_int = (__flash char*)( START_BASIC_PROGRAM ) + loc;   /* start program running at that loc */
  }
}

/* Return from GOSUB. */
void greturn()
{
   bas_prog_int = gpop();
}

/* GOSUB stack push function. */
void gpush(char __flash *s)
{
  bas_gtos++;

  if(bas_gtos==SUB_NEST) {
    serror(12,1);
    return;
  }

  bas_gstack[bas_gtos]=s;

}

/* GOSUB stack pop function. */
char __flash *gpop(void)
{
  if(bas_gtos==0) {
    serror(13,1);
    return 0;
  }

  return(bas_gstack[bas_gtos--]);
}

/* Entry point into parser. */
void get_exp(ARITH_BASE *result)

{
  get_token();
  if(!*bas_token) {
    serror(2,1);
    return;
  }
  level2(result);
  bas_prog_int -= last_token_len; /* return last token read to input stream */
}
__flash char _fmt_s_n_[] = "\r\nERROR:";

void serror(int error,char mode)
{
  putstr_P(_fmt_s_n_);
  putstr(int_to_str(error));


  putchar(',');

 if(mode)
  putstr(int_to_str(get_line_number(bas_prog_int)+1));
 else
  putstr(int_to_str(cur_line));

  cr_lf();

  if(mode)
    stop_executive();
}

int get_token(void)
{
char tmp8;
bas_token_type=0; bas_tok=0;

      bas_token=bas_prog_int;
      bas_token_type = *bas_prog_int++;
      switch(bas_token_type)
     {
     case FUNC:
     case COMMAND:
     case VARIABLE:
        bas_tok = *bas_prog_int++;
#ifdef MAXI_SYSTEM
        if((bas_token_type == COMMAND) && (bas_tok == INLINE))
        {
          bas_prog_int++;
          bas_int_number = *bas_prog_int++;
          bas_int_number <<= 8;
          bas_int_number += *bas_prog_int++;
          last_token_len = 5;
        }
     else if((bas_token_type == COMMAND) && (bas_tok == INTERRUPT))
        {
          bas_prog_int++;
          utmp8 = *bas_prog_int++;
          bas_int_number = *bas_prog_int++;
          bas_int_number <<= 8;
          bas_int_number += *bas_prog_int++;
          last_token_len = 6;
        }

        else
#endif /* MAXI_SYSTEM */

        last_token_len = 2;
     break;
     case NUMBER:
       bas_int_number = *bas_prog_int++;
       bas_int_number <<= 8;
       bas_int_number += *bas_prog_int++;
       last_token_len = 3;
     break;
     case STRING:
     break;
     case QUOTE:
       tmp8 = *bas_prog_int++;
       bas_token=bas_prog_int;
       bas_prog_int += tmp8;
       last_token_len = 2 + tmp8;
     break;
     default:
       last_token_len = 1;
       if(bas_token_type == 0x00)
            bas_tok = FINISHED;
       else if(bas_token_type == 0x0D)
            bas_tok = EOL;

       bas_token_type=DELIMITER;

       break;
     }
return bas_token_type;
}


/* Look up a a token's internal representation in the
   token table.
*/

char cmp_P(char __flash *s,char __flash *p)
{
return 1;
}

char look_up(char *s)
{
  register int i;
  char *p;

  /* convert to lowercase */
  p = s;
  while(*p){ *p = toupper(*p); p++; }

  /* see if token is in table */
  for(i=0; *table[i].command; i++)
      if(!strcmp_P(s, table[i].command))
                     return table[i].tok;
  return 0; /* unknown command */
}
char look_up_fun(char *s)
{
  register int i;
  char *p;

  /* convert to lowercase */
  p = s;
  while(*p){ *p = toupper(*p); p++; }

  /* see if token is in table */
  for(i=0; *func_table[i].command; i++)
      if(!strcmp_P(s, func_table[i].command))
                     return func_table[i].tok;
  return 0; /* unknown command */
}



/* Return true if c is a delimiter. */
int isdelim(char c)
{
  if(strchr(" ;,+-<>/*=():", c) || c==9 || c=='\r' || c==0)
    return 1;
  return 0;
}

/* Return 1 if c is space or tab. */
int iswhite(char c)
{
  if(c==' ' || c=='\t') return 1;
  else return 0;
}



/*  Add or subtract two terms. */
void level2(ARITH_BASE *result)

{
  register char  op;
  ARITH_BASE hold;

  level3(result);
  while((op = *bas_token) == '+' || op == '-' ||
                                    op == '%' ||
                                    op == '&' ||
                                    op == '^' ||
                                    op == '|')
  {
    get_token();
    level3(&hold);
    arith(op, result, &hold);
  }
}

/* Multiply or divide two factors. */
void level3(ARITH_BASE *result)
{
  register char  op;
  ARITH_BASE hold;

  level4(result);
  while((op = *bas_token) == '*' || op == '/') {
    get_token();
    level4(&hold);
    arith(op, result, &hold);
  }
}

/* Process integer exponent. */
void level4(ARITH_BASE *result)
{
  level5(result);
}

/* Is a unary + or -. */
void level5(ARITH_BASE *result)
{
  register char  op;

  op = 0;
  if((bas_token_type==DELIMITER) && *bas_token=='+' || *bas_token=='-') {
    op = *bas_token;
    get_token();
  }
  level6(result);
  if(op)
    unary(op, result);
}

/* Process parenthesized expression. */
void level6(ARITH_BASE *result)
{
  if((*bas_token == '(') && (bas_token_type == DELIMITER)) {
    get_token();
    level2(result);
    if(*bas_token != ')')
      serror(1,1);
    get_token();
  }
  else
    primitive(result);
}

/* Find value of number or variable. */
void primitive(ARITH_BASE *result)
{
short ndx;
char var;
  switch(bas_token_type) {
  case FUNC:
    *result = bas_functions(bas_tok);
    get_token();
    return;
  case VARIABLE:
    var = bas_tok;
    *result = bas_variables[var];

    get_token();
     if(*bas_token!='(')
                    return;
     get_exp(&ndx);
     if(array_table[var].size == 0)
        serror(14,1);
     if(ndx >= array_table[var].size)
        serror(17,1);
     *result = array_table[var].start[ndx];
     get_token();
     if(*bas_token!=')')
                    serror(0,1);
    get_token();
    return;
  case NUMBER:
    *result = bas_int_number;
    get_token();
    return;
  default:
    serror(0,1);
  }
}

/* Perform the specified arithmetic. */
void arith(char o, ARITH_BASE *r, ARITH_BASE *h)
{
//  register int t;//, ex;

  switch(o) {
    case '&':
      *r = *r & *h;
      break;
    case '^':
      *r = *r ^ *h;
      break;
    case '|':
      *r = *r | *h;
      break;
    case '-':
      *r = *r-*h;
      break;
    case '+':
      *r = *r+*h;
      break;
    case '*':
      *r = *r * *h;
      break;
    case '/':
      *r = (*r)/(*h);
      break;
    case '%':
//      t = (*r)/(*h);
//      *r = *r-(t*(*h));
      *r = *r % *h;
      break;
  }
}

/* Reverse the sign. */
void unary(char o, ARITH_BASE *r)
{
  if(o=='-') *r = -(*r);
}

short find_fix_label_by_ndx(short ndx)
{
char i;

  for(i=0;i<NUM_LAB;i++)
  {
   if(label_table[i].prog_ndx == ndx)
      return label_table[i].label_value;
  }
return -1;
}

char find_data_block(void)
{
char __flash  *ptr;
char search_result = 0;
ptr = bas_prog_int;
bas_prog_int = data_pointer;
do
{
   get_token();
   if ((bas_token_type==COMMAND) && (bas_tok == DATA))
       {
         search_result   = 1;
         break;
       } else
    if ((bas_token_type==COMMAND) && (bas_tok == REM))
        {
          bas_prog_int++;
          bas_prog_int += *bas_prog_int;
        }

}  while(!((bas_token_type==DELIMITER)&&(bas_tok == FINISHED)));
if(search_result)
{
data_pointer = bas_prog_int;
}
bas_prog_int = ptr;

return search_result;
}

void exec_restore(void)
{
short loc = 0;
   get_token();
   if(bas_token_type == NUMBER)
   {
    if((loc = label_table[bas_int_number].prog_ndx) == -1)
    serror(7,1); /* label not defined */
   }
   else
     if(bas_token_type == DELIMITER)
       {
        bas_prog_int -= last_token_len;
        loc = 0;
       }
     else
         serror(0,1);

      data_pointer = (__flash char*)( START_BASIC_PROGRAM) + loc;
      if(!find_data_block())
            serror(18,1); /* out of DATA */

}
void read_data(short *data)
{
char __flash  *ptr;
ptr = bas_prog_int;
bas_prog_int = data_pointer;

  while(1)
  {
   get_token();
   if(bas_token_type == NUMBER)
     {
       *data = bas_int_number;
       break;
     }
        else
          if(bas_tok == EOL)
           {
             //putstr("\r\nMet the end of line");
             data_pointer = bas_prog_int;
              bas_prog_int = ptr;

               if(!find_data_block())
                {
                  //putstr("\r\nThere are not more data blocks");
                  serror(18,1); /* out of DATA */
                }

               ptr = bas_prog_int;
             bas_prog_int = data_pointer;

           }
          else
          if(*bas_token != ',')
             { // putstr("\r\n Expected a comma");
              serror(0,1);
             }
}
  data_pointer = bas_prog_int;
  bas_prog_int = ptr;

}



void exec_read(void)
{
short *var;
var = get_var(0);
read_data(var);
}

void clear_label_table(void)
{
char i;
  for(i=0;i < NUM_LAB;i++)
  {
    label_table[i].label_value = -1;
    label_table[i].prog_ndx = -1;
  }
}



void stop_executive(void)
{
PF restart=0;
press_any_key();
restart(0);
}

short *get_var(char opt)
{
char var;
short *ptr,ndx;
  get_token();
  var = bas_tok; /* get the input var */
      get_token();
     if(*bas_token =='(')
     {
     get_exp(&ndx);
     if(ndx >= array_table[var].size)
        serror(17,1);
     if(array_table[var].size == 0)
        serror(14,1);
     ptr = &(array_table[var].start[ndx]);
     get_token();
     if(*bas_token !=')')
                serror(0,1);

     }
      else
       {
         bas_prog_int -= last_token_len;
         ptr = &(bas_variables[var]);
       }

  if(opt)
  {
  get_token();
  if(*bas_token!=',')
                    serror(0,1);
}
return ptr;
}

int get_line_number(char __flash  *ptr)
{
int cntr = 0;
char __flash *wp;

wp = bas_prog_int;

  bas_prog_int = (__flash char*)( START_BASIC_PROGRAM);
  for(;;)
  {
    bas_token_type = 0;
    bas_tok = 0;
    find_eol();
    bas_prog_int++;
    if(bas_prog_int >= ptr)
    break;
    cntr++;
  }
bas_prog_int = wp;

return cntr;
}

void exec_dim(void)
{
char var;
short size;

do{
get_token();
  if(bas_token_type != VARIABLE)
    serror(4,1);
  var = bas_tok;

  /* get the equals sign */
  get_token();
if(*bas_token != '(')
    serror(0,1);
   get_exp(&size);
  get_token();
if(*bas_token != ')')
    serror(0,1);
  if(array_table[var].size == 0)
   {
    array_table[var].size = size;
    if((array_table[var].start = malloc(sizeof(short) * size)) == 0)
                             serror(16,1);
   }
  else
   serror(15,1);
get_token();
} while (*bas_token==',');


}


