/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/

#ifndef __BASINT_H__
#define __BASINT_H__

#define TIME_OUT_ERROR  1
#define TWI_ERROR       2


#define ARITH_BASE short
#define NUM_IOPINS 40
#define RAM_START ((unsigned char*)0)

#define NUM_LAB   LABEL_BUFFER_SIZE/4
#define FOR_NEST 5
#define SUB_NEST 5

#define DELIMITER 1
#define VARIABLE  2
#define NUMBER    3
#define COMMAND   4
#define STRING	  5
#define QUOTE	  6
#define FUNC	  7
#define OPERATOR  8

#define PRINT 1
#define INPUT 2
#define IF    3
#define THEN  4
#define FOR   5
#define NEXT  6
#define TO    7
#define GOTO  8
#define EOL   9
#define FINISHED  11
#define GOSUB 12
#define RETURN 15
#define END 16
#define ADC 17
#define DAC 18
#define SETBIT 19
#define CLEARBIT 20
#define ELSE  21
#define DELAY 22
#define STOP  23
#define NORM  24
#define REM   25
#define DIM   26
#define DATA  27
#define READ  28
#define RESTORE  29
#define CLS          30
#define POKE         31
#define DEFPIN       32
#define AS           33
#define WRITEEEPROM  34
#define ROL        35
#define ROR        36
#define DIN         37
#define DOUT        38
#define AIN         39
#define IIN         40
#define PWM         41
#define SETADMUX    42
#define INLINE       43
#define INTERRUPT    44
#define DELETEVECTOR 45
#define ENABLE       46
#define DISABLE      47
#define PULSEOUT     49
#define SHIFTOUT     51
#define TOGGLE       52
#define PUTATOMIC    53
#define TWISTART     55
#define TWISTOP      56
#define TWIWRITE     57
#define TWIINIT      58
#define ATTR         59
#define PAPER        60
#define INK          61
#define LCDINIT      62
#define KEYINIT      63
#define OPENSERIAL     64
#define CLOSESERIAL    65
#define LEDON          66
#define LEDOFF         67
#define LEDTOGGLE      68 
#define DISCRETEON     69
#define DISCRETEOFF    70
#define DISCRETETOGGLE 71
#define DISCRETEOUTPUT 72 



#define HIGH       1
#define LOW        2
#define ABS        3
#define PEEK       4
#define GETATOMIC  5
#define PULSEIN    6
#define SHIFTIN    7
#define LASTERROR  8
#define READEEPROM 9
#define TESTBIT    10
#define TWIREAD    11
#define BIN        12
#define HEX        13
#define BCD        14
#define CHR        15
#define INKEY      16
#define WAITKEY    17
#define AT         18
#define CHN        19
#define DIPSWITCH     20
#define DISCRETEINPUT 21


#define OR    '|'
#define XOR   '^'
#define MOD   '%'
#define AND   '&'
#define NOT   '!'

typedef void (*PF)(short*);
#define true 1
#define false 0

typedef struct  { /* keyword lookup table */
  char __flash *command;
  char tok;
} commands_tbl;

typedef struct  { /* keyword lookup table */
  unsigned short in;
  unsigned short ddr;
  unsigned short out;
  unsigned char mask;
  unsigned char func;
} PIO_TABLE;


typedef struct
{
  PF func_ptr;
} VECTOR;



typedef struct {
  short  label_value; /* value as present in source*/
  short  prog_ndx;    /* points to place to go in source file*/
} FIX_LABEL;


typedef struct {
  short  size; /* value as present in source*/
  short  *start;    /* points to place to go in source file*/
} ARRAY_ELEMENT;

extern ARRAY_ELEMENT *array_table;

typedef struct {
  ARITH_BASE var; /* counter variable */
  ARITH_BASE target;  /* target value */
  char __flash *loc;
} FOR_STACK ;

//typedef struct {
extern __flash PIO_TABLE pio_table[];
extern char *bas_prog;  /* holds expression to be analyzed */
extern ARITH_BASE *bas_variables;//[26];
extern char *bas_token_ext;//[64];
extern char __flash *bas_token;
extern char bas_token_type;
extern char bas_tok;
extern ARITH_BASE bas_int_number;
extern FIX_LABEL label_table[NUM_LAB];
extern short cur_line;
extern int bas_ftos;  /* index to top of FOR stack */
extern int bas_gtos;  /* index to top of GOSUB stack */
extern FOR_STACK *bas_fstack;//[FOR_NEST]; /* stack for FOR/NEXT loop */
extern char __flash **bas_gstack;//[SUB_NEST];	/* stack for gosub */
extern unsigned short prog_ndx;
extern char cur_channel;
extern char __flash  *bas_prog_int;  /* holds expression to be analyzed */
extern char last_token_len;
extern char last_error;
extern unsigned char utmp8;
char *convert_line_to_intformat(unsigned short prog_ndx, char *p, char *wp);


void print(void);
void scan_labels(void);
void find_eol(void);
void exec_goto(void);
void exec_if(void);
void exec_for(void);
void next(void);
void fpush(FOR_STACK i);
void input_(void);
void gosub(void);
void greturn(void);
void gpush(char __flash *s);
void label_init(void);
void serror(int error,char mode);
void get_exp(ARITH_BASE *result);
void putback(void);
void level2(ARITH_BASE *result);
void level3(ARITH_BASE *result);
void level4(ARITH_BASE *result);
void level5(ARITH_BASE *result);
void level6(ARITH_BASE *result);
void primitive(ARITH_BASE *result);
void unary(char o, ARITH_BASE *r);
void arith(char o, ARITH_BASE *r, ARITH_BASE *h);
int get_token(void);
int get_text_token(void);
void assignment(void);
int get_next_label(char *s);
char __flash *find_label(char *s);
int iswhite(char c);
int isdelim(char c);
char look_up(char *s);
char look_up_fun(char *s);
int find_var(char *s);
FOR_STACK fpop(void);
char __flash *gpop(void);
void get_param(ARITH_BASE *result);
short *get_var(char opt);
int get_line_number(char __flash  *ptr);
void show_label_table(void);
void clear_label_table(void);
void listing_restore(void);
void exec_dim(void);
int get_line_number(char __flash  *ptr);
void stop_executive(void);
void exec_read(void);
void read_data(short *data);
void exec_restore(void);
char find_data_block(void);
short find_fix_label_by_ndx(short ndx);


extern __flash commands_tbl opers_table[];
extern __flash commands_tbl table[];
extern __flash commands_tbl func_table[];

#endif

