/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"

#ifdef DBOARD_40PIN_MEGA16

#define PORTA_IN   0x39
#define PORTA_DDR  0x3A
#define PORTA_OUT  0x3B

#define PORTB_IN   0x36
#define PORTB_DDR  0x37
#define PORTB_OUT  0x38

#define PORTC_IN   0x33
#define PORTC_DDR  0x34
#define PORTC_OUT  0x35

#define PORTD_IN   0x30
#define PORTD_DDR  0x31
#define PORTD_OUT  0x32

__flash PIO_TABLE pio_table[] = {

   /* P00 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<0),64+0,
   /* P01 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<1),64+1,
   /* P02 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<2),64+2,
   /* P03 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<3),64+3,
   /* P04 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<4),64+4,
   /* P05 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<5),64+5,
   /* P06 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<6),64+6,
   /* P07 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<7),64+7,

   /* P08 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<0),0,
   /* P09 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<1),0,
   /* P10 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<2),0,
   /* P11 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<3),0,
   /* P12 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<4),0,
   /* P13 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<5),0,
   /* P14 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<6),0,
   /* P15 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<7),0,

   /* P16 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<0),0,
   /* P17 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<1),0,
   /* P18 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<2),0,
   /* P19 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<3),0,
   /* P20 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<4),0,
   /* P21 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<5),0,
   /* P22 */   0,0,0,0,0,
   /* P23 */   0,0,0,0,0,

   /* P24 */   0,0,0,0,0,
   /* P25 */   0,0,0,0,0,
   /* P26 */   0,0,0,0,0,
   /* P27 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<3),0,
   /* P28 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<4),128+1,
   /* P29 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<5),128+0,
   /* P30 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<6),0,
   /* P31 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<7),0,

};
#endif

#ifdef DBOARD_40PIN_MEGA32

#define PORTA_IN   0x39
#define PORTA_DDR  0x3A
#define PORTA_OUT  0x3B

#define PORTB_IN   0x36
#define PORTB_DDR  0x37
#define PORTB_OUT  0x38

#define PORTC_IN   0x33
#define PORTC_DDR  0x34
#define PORTC_OUT  0x35

#define PORTD_IN   0x30
#define PORTD_DDR  0x31
#define PORTD_OUT  0x32

__flash PIO_TABLE pio_table[] = {

   /* P00 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<0),64+0,
   /* P01 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<1),64+1,
   /* P02 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<2),64+2,
   /* P03 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<3),64+3,
   /* P04 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<4),64+4,
   /* P05 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<5),64+5,
   /* P06 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<6),64+6,
   /* P07 */   PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<7),64+7,

   /* P08 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<0),0,
   /* P09 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<1),0,
   /* P10 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<2),0,
   /* P11 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<3),0,
   /* P12 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<4),0,
   /* P13 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<5),0,
   /* P14 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<6),0,
   /* P15 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<7),0,

   /* P16 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<0),0,
   /* P17 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<1),0,
   /* P18 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<2),0,
   /* P19 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<3),0,
   /* P20 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<4),0,
   /* P21 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<5),0,
   /* P22 */   0,0,0,0,0,
   /* P23 */   0,0,0,0,0,

   /* P24 */   0,0,0,0,0,
   /* P25 */   0,0,0,0,0,
   /* P26 */   0,0,0,0,0,
   /* P27 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<3),0,
   /* P28 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<4),128+1,
   /* P29 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<5),128+0,
   /* P30 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<6),0,
   /* P31 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<7),0,
};

#endif

#ifdef ABSTRACT_MEGA64_128

#define PORTB_IN   0x36
#define PORTB_DDR  0x37
#define PORTB_OUT  0x38

#define PORTC_IN   0x33
#define PORTC_DDR  0x34
#define PORTC_OUT  0x35

#define PORTD_IN   0x30
#define PORTD_DDR  0x31
#define PORTD_OUT  0x32

#define PORTF_IN   0x20
#define PORTF_DDR  0x61
#define PORTF_OUT  0x62

#define PORTE_IN   0x21
#define PORTE_DDR  0x22
#define PORTE_OUT  0x23

#define PORTA_IN   0x39
#define PORTA_DDR  0x3A
#define PORTA_OUT  0x3B

#define PORTG_IN   0x63
#define PORTG_DDR  0x64
#define PORTG_OUT  0x65



__flash PIO_TABLE pio_table[] = {

/* P0 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<0),0,
/* P1 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<1),0,
/* P2 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<2),0,
/* P3 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<3),0,

/* P4 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<4),0,
/* P5 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<5),0,
/* P6 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<6),0,
/* P7 */    PORTA_IN,PORTA_DDR,PORTA_OUT,(1<<7),0,

   /* P8 */    PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<0),0,
   /* P9 */    PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<1),0,
   /* P10 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<2),0,
   /* P11 */   PORTB_IN,PORTB_DDR,PORTB_OUT,(1<<3),0,

   /* P12 */   PORTB_IN,PORTC_DDR,PORTB_OUT,(1<<4),0,
   /* P13 */   PORTB_IN,PORTC_DDR,PORTB_OUT,(1<<5),128+0,
   /* P14 */   PORTB_IN,PORTC_DDR,PORTB_OUT,(1<<6),128+1,
   /* P15 */   PORTB_IN,PORTC_DDR,PORTB_OUT,(1<<7),128+2,

   /* P16 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<0),0,
   /* P17 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<1),0,
   /* P18 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<2),0,
   /* P19 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<3),0,

   /* P20 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<4),0,
   /* P21 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<5),0,
   /* P22 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<6),0,
   /* P23 */   PORTC_IN,PORTC_DDR,PORTC_OUT,(1<<7),0,

   /* P24 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<0),0,
   /* P25 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<1),0,
   /* P26 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<2),0,
   /* P27 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<3),0,

   /* P28 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<4),0,
   /* P29 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<5),0,
   /* P30 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<6),0,
   /* P31 */   PORTD_IN,PORTD_DDR,PORTD_OUT,(1<<7),0,

/* 32 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<0),0,
/* 33 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<1),0,
/* 34 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<2),0,
/* 35 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<3),0,

/* 36 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<0),0,
/* 37 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<1),0,
/* 38 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<2),0,
/* 39 */    PORTE_IN,PORTE_DDR,PORTE_OUT,(1<<3),0,

/* 40 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<0),64+0,
/* 41 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<1),64+1,
/* 42 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<2),64+2,
/* 43 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<3),64+3,

/* 44 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<0),64+4,
/* 45 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<1),64+5,
/* 46 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<2),64+6,
/* 47 */    PORTF_IN,PORTF_DDR,PORTF_OUT,(1<<3),64+7,

/* 48 */    PORTG_IN,PORTG_DDR,PORTG_OUT,(1<<0),0,
/* 49 */    PORTG_IN,PORTG_DDR,PORTG_OUT,(1<<1),0,
/* 50 */    PORTG_IN,PORTG_DDR,PORTG_OUT,(1<<2),0,
/* 51 */    PORTG_IN,PORTG_DDR,PORTG_OUT,(1<<3),0

};

#endif

