/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "typedef.h"

#ifndef  __SCOMDRIV_H__
#define  __SCOMDRIV_H__


enum {NOPARITY=0x00,ODDPARITY=0x08,EVENPARITY=0x18,MARKPARITY=0x28,SPACEPARITY=0x38};
enum {RTS_HIGH,RTS_LOW,RTS_TOGGLE};
enum {ONE_STOP_BITS=0x00,TWO_STOP_BITS=0x04};
enum {DATA_5_BITS=0,DATA_6_BITS=1,DATA_7_BITS=2,DATA_8_BITS=3};

#define COM1  0
#define COM2  1
#define COM3  9
#define COM4  8
#define COM5  7
#define COM6  6
#define COM7  4
#define COM8  5
#define COM9  2
#define COM10 3


typedef struct {

// interface part
INT32 BaudRate;   // just a numeric value of baud rate in bps, default: 19200
INT8 DataBits; // number of data bits from 5 to 8, default: 8
INT8 StopBits; // number of stop bits from 1 to 2, default: 1
INT8 Parity; // parity check:
             //             EVENPARITY
             //             MARKPARITY
             //             NOPARITY
             //             ODDPARITY
             // default: NOPARITY
INT8 RTS_mode; // RTS_HIGH
               // RTS_LOW
               // RTS_TOGGLE
               // default: RTS_LOW
// This field is actually needed for RS485/422 modes to control
// RX/TS state of transceivers. If RTS_mode set to RTS_TOGGLE it 
// set RTS automatically and restart RTS_ReleaseDelay when send byte and clear 
// after RTS_ReleaseDelay expired

UINT8 TxDelay;   // This field is actually needed for RS485/422 modes,
                 // default: 50 ms
UINT8 SymTimeOut;// This field is actually needed for packet modes, 
                 // default: 2 ms

UINT8 RTS_ReleaseDelay;
//================================================================
//                    private part of structure
//================================================================
UINT8 *txbuff;
UINT8 *rxbuff;
UINT16 tx_wr_ndx;
INT16 tx_rd_ndx;
INT16 rx_wr_ndx;
INT16 rx_rd_ndx;
INT16 rx_bsize;
INT16 tx_bsize;
INT16 rx_cnt;
INT16 tx_cnt;
UINT8 tx_ready;
} SERIAL_DCB;

extern SERIAL_DCB serial_dcb[2];


UINT8 create_uart_DCB (SERIAL_DCB *dcb, INT16 rxbufsize, INT16 txbufsize);
void set_uart_DCB (UINT8 port, SERIAL_DCB  *dcb);
INT16 uart_getchar (UINT8 port);
UINT8 uart_putchar (UINT8 port, UINT8 ch);
INT16 uart_putstr (UINT8 port, INT8 *data);
INT16 uart_putstr_P (UINT8 port, INT8 __flash *data);
INT16 uart_putblock (UINT8 port, INT8 *data, INT16 len);
void on_uart_tx_isr(UINT8 port);
void on_uart_rx_isr(UINT8 port, UINT8 data);
void UART_SEND_BYTE(UINT8 port, UINT8 c);
void fill_default_dcb (SERIAL_DCB *dcb);
UINT8 open_port(UINT8 port, INT32 baud_rate,UINT16 rxbufsize, UINT16 txbufsize);
void close_port(UINT8 port);




#endif

