/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"

char key_flag = 0;
char lcd_type = 0;
short sym_counter = 0;
void lcd_set_data(unsigned char data)
{
  PORTA = (PORTA & 0x0F) | (data & 0xF0);
}

void lcd_delay(void)
{
short tim=10000;
while(--tim);
}
void EN_pulse(void)
{
char i=3;
     while(--i);
     LCD_E_HIGH();
     i=3;
     while(--i);
     LCD_E_LOW();
     i=3;
     while(--i);
}

void LCD_WriteByte(unsigned char bt)
{
unsigned char i=100;
//          LCD_RW_LOW();
          LCD_E_LOW();
          lcd_set_data(bt);
        EN_pulse();
          lcd_set_data(bt<<4);
        EN_pulse();
   while(--i);
}

void LCD_WriteCommand(unsigned char bt)
{
   LCD_RS_LOW();
   LCD_WriteByte(bt);
}
void LCD_WriteData(unsigned char bt)
{
   LCD_RS_HIGH();
   LCD_WriteByte(bt);
   sym_counter++;
                    if((sym_counter>7)&&(sym_counter<64) && (lcd_type == LCD_16X1_TYPE1))
                        {
                          sym_counter = (sym_counter & 0x07)  + 64;
                          LCD_WriteCommand(128 + sym_counter);
                        }
      }

// ESC[2J             clears screen and set cursor at 1;1
// ESC[<row>;<col>f   sets cursor at row;col
// ESC[f              sets cursor at 1;1
// ESC[<row>;<col>H   sets cursor at row;col  like f-command
// ESC[H              sets cursor at 1;1      like f-command
// ESC[<shifts>C      shifts cursor <shifts> positions right
// ESC[C              shifts cursor 1 position right
// ESC[<shifts>D      shifts cursor <shifts> positions left
// ESC[D              shifts cursor 1 positions left
// 0x08               shifts cursor 1 positions left
// 0x0A               ignored
// 0x0C               clears screen and set cursor at 1;1
// 0x0D               ignored
// ESC[0C              shows cursor
// ESC[0D              hides cursor


void LCD_putstr(char *str)
{
while(*str!=0x00)
    ANSI_input_stream_parser(*str++);

}



void LCD_init(char lcdtype)
{
lcd_type = lcdtype;
          LCD_PINS_INIT();
// --------- Set 8 bits mode ----------
//          LCD_RW_LOW();
          LCD_RS_LOW();
          LCD_E_LOW();
          lcd_set_data(0x30);
          EN_pulse();
          lcd_delay();
          EN_pulse();
          lcd_delay();
          EN_pulse();
          lcd_delay();
// --------- set 4 bits mode ----------
          lcd_set_data(0x20);
          EN_pulse();
          lcd_delay();
          LCD_WriteCommand(0x28);
          LCD_WriteCommand(0x0E);
          LCD_WriteCommand(0x06);
          LCD_WriteCommand(0x01);
          lcd_delay();
          LCD_WriteCommand(0x02);
          lcd_delay();
}

enum {
        WAIT_FOR_ESC,
        WAIT_FOR_BRACKET,
        WAIT_FOR_PARAMS,
        WAIT_FOR_COMMAND
};

char ANSI_terminal_state = WAIT_FOR_ESC;

static char param_buf[5];
static char *str;
static unsigned char params[3],i;
static char param_ndx;

void ANSI_input_stream_parser(char ch)
{
        switch(ANSI_terminal_state)
        {
          case WAIT_FOR_ESC:
           if(ch == 0x1B)
             ANSI_terminal_state = WAIT_FOR_BRACKET;
           else
                 {
                   if(ch == 0x08)
                   {
                     sym_counter--;
                        if(sym_counter<0)
                                     sym_counter=0;
                      if((sym_counter<64) && (lcd_type == LCD_16X1_TYPE1))
                        {
                          sym_counter &= 0x07;
                          LCD_WriteCommand(128 + sym_counter);
                        }
                         else
                           LCD_WriteCommand(0x10);

                   }
                   else if(ch != 13 && ch != 10)
                       LCD_putchar(ch);
                 }

          break;
          case WAIT_FOR_BRACKET:
           if(ch == '[')
            {
              params[0] = 1;
              params[1] = 1;
              params[2] = 1;
              param_ndx = 0;
              str = param_buf;
              ANSI_terminal_state = WAIT_FOR_PARAMS;
            }
              else
                ANSI_terminal_state = WAIT_FOR_ESC;
          break;
          case WAIT_FOR_PARAMS:
             if(isdigit(ch))
               {
                *str++ = ch;
                break;
               }
               else
                {
                    *str++ = 0x00;
                    params[param_ndx] = atoi(param_buf);
                    if(ch == ';')
                      {
                       str = param_buf;
                       param_ndx++;
                       break;
                      }
                     else
                       ANSI_terminal_state = WAIT_FOR_COMMAND;
                }

          case WAIT_FOR_COMMAND:
                switch(ch)
                {
                 case 'H':
                 case 'f':
                     if(lcd_type == LCD_16X1_TYPE1)
                     {
                       i = params[1];
                        if((i>7) && (i<64)) i = (i & 0x07) + 64;
                     }
                      else
                        {
                         i = (params[0] - 1) * 64 + (params[1] - 1);
                        }
                      sym_counter = i;
                      LCD_WriteCommand(128 | i);
                 break;
                 case 'C':
                           i=params[0];
                           if(i==0) LCD_WriteCommand(0x0E);
                           while(i--)
                              {
                                sym_counter++;
                      if(
                         (sym_counter>7)&&
                         (sym_counter<64) && (lcd_type == LCD_16X1_TYPE1))
                        {
                          sym_counter = (sym_counter & 0x07) + 64;
                          LCD_WriteCommand(128 + sym_counter);
                        }
                         else
                                LCD_WriteCommand(0x14);
                 break;
                 case 'D':

                           i =params[0];
                           if(i==0) LCD_WriteCommand(0x0C);
                           while(i--)
                           {
                        sym_counter--;
                        if(sym_counter<0)
                                     sym_counter=0;
                      if((sym_counter<64) && (lcd_type == LCD_16X1_TYPE1))
                        {
                          sym_counter &= 0x07;
                          LCD_WriteCommand(128 + sym_counter);
                        }
                         else
                           LCD_WriteCommand(0x10);
                        }
                               str++;
                         }

                 break;
                 case 'J':
                  if(params[0] == 2)
                  {
                    LCD_WriteCommand(1);
                                lcd_delay();
                    LCD_WriteCommand(2);
                                lcd_delay();
                    sym_counter = 0;
                  }
                 break;
                }
             ANSI_terminal_state = WAIT_FOR_ESC;
           }

}

char status_key(unsigned char mask)
{
char key;
  lcd_set_data(mask);
    delay_ms(2);
    if((key  = PINB & 0x1C) != 0x1C)
      return key;
key_flag = 0;
return 0;
}

char scan_decoder(char scan_code)
{
 switch(scan_code)
 {
 case 28: return '1';
 case 24: return '2';
 case 16: return '3';
 case 27: return '4';
 case 23: return '5';
 case 15: return '6';
 case 26: return '7';
 case 22: return '8';
 case 14: return '9';
 case 25: return 8;
 case 21: return '0';
 case 13: return 10;
 }
return 0;
}

short get_key(void)
{
char key;
if (! status_key(0))
     return -1;

if (key_flag)
    return -1;


 if ( (key = status_key(0x70))) key += 1;
else if ( (key = status_key(0xB0))) key += 2;
else if ( (key = status_key(0xD0))) key += 3;
else if ( (key = status_key(0xE0))) key += 4;
else return -1;

key_flag = 1;
return scan_decoder(key);
}

void keyinit_exec(void)
{
  DDRA |= 0xF0;
  DDRB &= ~0x1C;
  PORTB |= 0x1C;
}

