/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"

#ifdef MAXI_SYSTEM
__flash char   _inline_[] = "INLINE";
__flash char   _interrupt_[] = "INTERRUPT";
__flash char   _deletevector_[] = "DELETEVECTOR";
__flash char   _enable_[] = "ENABLE";
__flash char   _disable_[] = "DISABLE";
__flash char   _putatomic_[] = "PUTATOMIC";
__flash char   _cls_[] = "CLS";
__flash char   _attr_[] = "ATTR";
__flash char   _paper_[] = "PAPER";
__flash char   _ink_[] = "INK";
__flash char   _lcdinit_[] = "LCDINIT";
__flash char   _keyinit_[] = "KEYINIT";
#endif

#ifdef IO_CONTROLLER_WITH_ATMEGA64
__flash char   _openserial_[] = "OPENSERIAL";
__flash char   _closeserial_[] = "CLOSESERIAL";
__flash char   _ledon_[] = "LEDON";
__flash char   _ledoff_[] = "LEDOFF";
__flash char   _ledtoggle_[] = "LEDTOGGLE";
__flash char   _discreteon_[] = "DISCRETEON";
__flash char   _discreteoff_[] = "DISCRETEOFF";
__flash char   _discretetoggle_[] = "DISCRETETOGGLE";
__flash char   _discreteoutput_[] = "DISCRETEOUTPUT";
#endif

__flash char _print_[] =  "PRINT";
__flash char _input_[] =  "INPUT";
__flash char _if_[] =     "IF";
__flash char _then_[] =   "THEN";
__flash char _goto_[] =   "GOTO";
__flash char _for_[] =    "FOR";
__flash char _next_[] =   "NEXT";
__flash char _to_[] =     "TO";
__flash char _gosub_[] =  "GOSUB";
__flash char _return_[] = "RETURN";
__flash char _end_[] =    "END";
__flash char _empty_[] =   "";
__flash char   _adc_[] = "ADC";
__flash char   _dac_[] = "DAC";
__flash char   _setbit_[] = "SET";
__flash char   _clearbit_[] = "CLEAR";
__flash char   _delay_[] = "DELAY";
__flash char   _norm_[] = "SCALE";
__flash char   _rem_[] = "REM";
__flash char   _dim_[] = "DIM";
__flash char   _data_[] = "DATA";
__flash char   _read_[] = "READ";
__flash char   _restore_[] = "RESTORE";
__flash char _poke_[] = "POKE";

__flash char _writeeeprom_[] = "WRITEEEPROM";
__flash char   _rol_[] = "ROL";
__flash char   _ror_[] = "ROR";
__flash char _defpin_[] = "DEFPIN";
__flash char _as_[] = "AS";
__flash char   _din_[] = "DIN";
__flash char   _dout_[] = "DOUT";
__flash char   _ain_[] = "AIN";
__flash char   _diin_[] = "";
__flash char   _pwm_[] = "PWM";
__flash char   _setadmux_[] = "SETADMUX";
__flash char   _pulseout_[] = "PULSEOUT";
__flash char   _shiftout_[] = "SHIFTOUT";
__flash char   _toggle_[] = "TOGGLE";
__flash char   _bitwait_[] = "BITWAIT";
__flash char   _stop_[] = "STOP";
__flash char   _else_[] = "ELSE";
__flash char   _twistart_[] = "TWISTART";
__flash char   _twistop_[] = "TWISTOP";
__flash char   _twiwrite_[] = "TWIWRITE";
__flash char   _twiinit_[] = "TWIINIT";


__flash commands_tbl table[] = { /* Commands must be entered lowercase */
#ifdef MAXI_SYSTEM
  _enable_,ENABLE,
  _disable_,DISABLE,
  _inline_,INLINE,
  _interrupt_,INTERRUPT,
  _deletevector_,DELETEVECTOR,
  _putatomic_,PUTATOMIC,
  _attr_,ATTR,
  _paper_,PAPER,
  _ink_,INK,
  _cls_,CLS,
  _lcdinit_,LCDINIT,
  _keyinit_,KEYINIT,
#endif

#ifdef IO_CONTROLLER_WITH_ATMEGA64
_openserial_,OPENSERIAL,
_closeserial_,CLOSESERIAL,
_ledon_,LEDON,
_ledoff_,LEDOFF,
_ledtoggle_,LEDTOGGLE,
_discreteon_,DISCRETEON,
_discreteoff_,DISCRETEOFF,
_discretetoggle_,DISCRETETOGGLE,
_discreteoutput_,DISCRETEOUTPUT,
#endif

  _print_, PRINT, /* in this table. */
  _input_, INPUT,
  _if_, IF,
  _then_, THEN,
  _goto_, GOTO,
  _for_, FOR,
  _next_, NEXT,
  _to_, TO,
  _gosub_, GOSUB,
  _return_, RETURN,
  _adc_,ADC,
  _dac_,DAC,
  _setbit_, SETBIT,
  _clearbit_,CLEARBIT,
  _delay_,DELAY,
  _end_, END,
  _norm_,NORM,
  _rem_,REM,
  _dim_,DIM,
  _data_,DATA,
  _read_,READ,
  _restore_,RESTORE,
  _stop_, STOP,
  _poke_,POKE,
  _defpin_,DEFPIN,
  _as_,AS,
  _writeeeprom_,WRITEEEPROM,
  _rol_,ROL,
  _ror_,ROR,
  _din_,DIN,
  _dout_,DOUT,
  _ain_,AIN,
  _pulseout_,PULSEOUT,
  _shiftout_,SHIFTOUT,
  _toggle_,TOGGLE,
  _pwm_,PWM,
  _setadmux_,SETADMUX,
  _twistart_,TWISTART,
  _twistop_,TWISTOP,
  _twiwrite_,TWIWRITE,
  _twiinit_,TWIINIT,
  _else_,ELSE,
  _empty_, 0  /* mark end of table */
};

#ifdef MAXI_SYSTEM
__flash char   _getatomic_[] = "GETATOMIC";
__flash char   _at_[] = "AT";
__flash char   _bin_[] = "BIN";
__flash char   _hex_[] = "HEX";
__flash char   _bcd_[] = "BCD";
__flash char   _chn_[] = "CHN";

#endif

__flash char   _high_[] = "HIGH";
__flash char   _low_[] = "LOW";
__flash char   _abs_[] = "ABS";
__flash char   _peek_[] = "PEEK";
__flash char   _readeeprom_[] = "READEEPROM";
__flash char   _testbit_[] = "TEST";
__flash char   _pulsein_[] = "PULSEIN";
__flash char   _shiftin_[] = "SHIFTIN";
__flash char   _lasterror_[] = "LASTERROR";
__flash char   _rxready_[] = "RXREADY";
__flash char   _twiread_[] = "TWIREAD";
__flash char   _chr_[] = "CHR";
__flash char   _inkey_[] = "INKEY";
__flash char   _waitkey_[] = "WAITKEY";


#ifdef IO_CONTROLLER_WITH_ATMEGA64
__flash char   _dipswitch_[] = "DIPSWITCH";
__flash char   _discreteinput_[] = "DISCRETEINPUT";
#endif



__flash commands_tbl func_table[] = { /* Commands must be entered lowercase */
#ifdef MAXI_SYSTEM
  _getatomic_,GETATOMIC,
  _at_,AT,
  _bin_,BIN,
  _hex_,HEX,
  _bcd_,BCD,
  _chn_,CHN,
#endif
#ifdef IO_CONTROLLER_WITH_ATMEGA64
_dipswitch_,DIPSWITCH,
_discreteinput_,DISCRETEINPUT,
#endif
  _high_,HIGH,
  _low_,LOW,
  _abs_,ABS,
  _peek_,PEEK,
  _readeeprom_,READEEPROM,
  _testbit_,TESTBIT,
  _pulsein_,PULSEIN,
  _shiftin_,SHIFTIN,
  _lasterror_,LASTERROR,
  _twiread_,TWIREAD,
  _chr_,CHR,
  _inkey_,INKEY,
  _waitkey_,WAITKEY,
 _empty_, 0  /* mark end of table */
};

__flash char   _or_[] = "OR";
__flash char   _xor_[] = "XOR";
__flash char   _mod_[] = "MOD";
__flash char   _and_[] = "AND";
__flash char   _not_[] = "NOT";

__flash commands_tbl opers_table[] = { /* Operators */
  _or_,OR,
  _xor_,XOR,
  _mod_,MOD,
  _and_,AND,
  _not_,NOT,
 _empty_, 0  /* mark end of table */
};
